////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "About.h"
//
// Copyright (C) 2002-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__ABOUT__
#define __FILE__ABOUT__

#include "../Control/ButtonFM.h"
#include "../Control/EditFM.h"
#include "../Resource.h"

#ifndef _WTL_VER

class CDialogAbout {
public:
   HWND m_hWnd;
private:
   CButtonImageFM m_BtnLogo;
 //CButtonImageFM m_BtnMail;
   CButtonExFM    m_BtnOk;
   CEditFM        m_EditICQAdress;
private:
   static LPCTSTR IDD() { static TCHAR szResourceName[] = _T("About"); return szResourceName; }
   static INT_PTR CALLBACK DialogProcThis(HWND, UINT, WPARAM, LPARAM);
   INT_PTR DialogProc(HWND, UINT uMsg, WPARAM wParam, LPARAM lParam) {
      switch (uMsg){
      HANDLE_MSG(m_hWnd, WM_INITDIALOG, OnInitDialog);
      HANDLE_MSG(m_hWnd, WM_COMMAND   , OnCommand);
      HANDLE_MSG(m_hWnd, WM_CLOSE     , OnClose);
      HANDLE_MSG(m_hWnd, WM_DESTROY   , OnDestroy);
      HANDLE_MSG(m_hWnd, WM_ERASEBKGND, OnEraseBkgnd);
    //HANDLE_WM_EX_CTLCOLOR(m_hWnd, gpFM2Proj->GetSkin());
      }
      return FALSE;
   }
public:
   CDialogAbout() : m_hWnd(NULL) {}
   HWND Create(HWND);
private:
   BOOL OnInitDialog(HWND, HWND, LPARAM);
   void OnCommand   (HWND, int, HWND, UINT);
   void OnClose     (HWND);
   void OnDestroy   (HWND);
   BOOL OnEraseBkgnd(HWND, HDC);
};

////////////////////////////////////////////////////////////////////////////////////////////////////////
#else // _WTL_VER
////////////////////////////////////////////////////////////////////////////////////////////////////////

class CDialogAbout : public CDialogImpl<CDialogAbout>, public CWinDataExchange<CDialogAbout>
{
private:
   CButtonImageFM m_BtnLogo;
 //CButtonImageFM m_BtnMail;
   CButtonExFM    m_BtnOk;
	CHyperLink     m_HyperLink_UkrPost;
	CHyperLink     m_HyperLink_Site;
	CHyperLink     m_HyperLink_License;
   CEditFM        m_EditICQAdress;
public:
   static LPCTSTR IDD() { static TCHAR szResourceName[] = _T("About"); return szResourceName; }//enum { IDD = 0 };

	// modeless dialogs
	HWND Create(HWND hWndParent, LPARAM dwInitParam = NULL);

private:
   BEGIN_MSG_MAP_EX(CDialogAbout)
      MSG_WM_INITDIALOG(OnInitDialog)
      MSG_WM_COMMAND   (OnCommand)
      MSG_WM_CLOSE     (OnClose)
      MSG_WM_DESTROY   (OnDestroy)
      MSG_WM_ERASEBKGND(OnEraseBkgnd)
   END_MSG_MAP()
	BEGIN_DDX_MAP(CDialogAbout)
		DDX_CONTROL(IDC_ABOUT_ICON_PROJ , m_BtnLogo)
		DDX_CONTROL(IDOK                , m_BtnOk)
		DDX_CONTROL(IDC_ABOUT_UKRPOST   , m_HyperLink_UkrPost)
		DDX_CONTROL(IDC_ABOUT_SITE      , m_HyperLink_Site)
		DDX_CONTROL(IDC_ABOUT_COMMENTS  , m_HyperLink_License)
      DDX_CONTROL(IDC_ABOUT_ICQADDRESS, m_EditICQAdress)
	END_DDX_MAP()

   BOOL OnInitDialog(HWND, LPARAM);
   void OnCommand(UINT, int, HWND);
   void OnClose();
   void OnDestroy();
   BOOL OnEraseBkgnd(HDC hDC);
};

#endif // _WTL_VER

#endif // __FILE__ABOUT__
