////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "AssistantDlg.cpp"
//    "m_AssistantInfo Options"
// Copyright (C) 2003-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "AssistantDlg.h"
#include "../FastMines2.h"
#include "../EraseBk.h"
#include "../Lang.h"
#include "./DialogMessageHook.h"

////////////////////////////////////////////////////////////////////////////////
//                      global variables, types , defines, etc...
////////////////////////////////////////////////////////////////////////////////
extern CFastMines2WinMain& GetFM2WinMain();

WNDPROC_STATIC(IDC_ASSISTANT_STATIC_FIRST        , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ASSISTANT_STATIC_NEXT         , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ASSISTANT_STATIC_SECOND       , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ASSISTANT_STATIC_MILISECOND   , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ASSISTANT_SPIN_FIRST          , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ASSISTANT_SPIN_NEXT           , GetFM2WinMain().GetSkin())
WNDPROC_BUTTON(IDC_ASSISTANT_CHECKBOX_AUTOSTART  , GetFM2WinMain().GetSkin())
WNDPROC_BUTTON(IDC_ASSISTANT_CHECKBOX_STOPWORK   , GetFM2WinMain().GetSkin())
WNDPROC_BUTTON(IDC_ASSISTANT_CHECKBOX_IGNOREPAUSE, GetFM2WinMain().GetSkin())

#define maxTimeoutFirst UD_MAXVAL //  !
#define minTimeoutFirst 1         //  !
#define maxTimeoutNext  5000      //  !
#define minTimeoutNext  100       //  !

////////////////////////////////////////////////////////////////////////////////
//                          implementation
////////////////////////////////////////////////////////////////////////////////

#ifndef _WTL_VER

HWND CDialogAssistant::Create(HWND hWndParent) {
   return ::CreateDialogParam(::GetModuleHandle(NULL), CDialogAssistant::IDD(), hWndParent, (DLGPROC)CDialogAssistant::DialogProcThis, (LPARAM)this);
}

/*static*/ INT_PTR CALLBACK CDialogAssistant::DialogProcThis(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
   //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogAssistant::DialogProcThis: %s "), (LPCTSTR)CLogger::WindowMessage(uMsg));
   CDialogAssistant *This = NULL;
   if (uMsg == WM_INITDIALOG) {
      This = (CDialogAssistant*)lParam;
      if (This) {
         This->m_hWnd = hWnd;
         ::SetWindowUserData(hWnd, (LONG_PTR)This);
      }
   } else {
      This = (CDialogAssistant*)::GetWindowUserData(hWnd);
   }
   if (This) {
      return This->DialogProc(hWnd, uMsg, wParam, lParam);
   }
   return FALSE;
}

BOOL CDialogAssistant::OnInitDialog(HWND, HWND hWndFocus, LPARAM lParam) {
   m_BtnOk    .SubclassWindow(::GetDlgItem(m_hWnd, IDOK));
   m_EditFirst.SubclassWindow(::GetDlgItem(m_hWnd, IDC_ASSISTANT_EDIT_FIRST));
   m_EditNext .SubclassWindow(::GetDlgItem(m_hWnd, IDC_ASSISTANT_EDIT_NEXT ));

   ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_CHECKBOX_AUTOSTART  , BM_SETCHECK, m_AssistantInfo.m_bAutoStart   ? BST_CHECKED : BST_UNCHECKED, 0);
   ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_CHECKBOX_STOPWORK   , BM_SETCHECK, m_AssistantInfo.m_bStopWork    ? BST_CHECKED : BST_UNCHECKED, 0);
   ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_CHECKBOX_IGNOREPAUSE, BM_SETCHECK, m_AssistantInfo.m_bIgnorePause ? BST_CHECKED : BST_UNCHECKED, 0);

   m_AssistantInfo = GetFM2WinMain().GetAssistantInfo();

   ::SetWindowText(m_hWnd                                                  , CLang::GetString(IDS__DIALOG_ASSISTANT                    ));
   ::SetWindowText(m_BtnOk.m_hWnd                                          , CLang::GetString(IDS__OK                                  ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ASSISTANT_STATIC_FIRST        ), CLang::GetString(IDS__DIALOG_ASSISTANT__TIMEOUT_USER_FIRST));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ASSISTANT_STATIC_NEXT         ), CLang::GetString(IDS__DIALOG_ASSISTANT__TIMEOUT_NEXT      ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ASSISTANT_STATIC_SECOND       ), CLang::GetString(IDS__SECOND                              ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ASSISTANT_STATIC_MILISECOND   ), CLang::GetString(IDS__MILISECOND                          ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ASSISTANT_CHECKBOX_AUTOSTART  ), CLang::GetString(IDS__DIALOG_ASSISTANT__NEW_GAME_AUTOSTART));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ASSISTANT_CHECKBOX_STOPWORK   ), CLang::GetString(IDS__DIALOG_ASSISTANT__STOPWORK          ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ASSISTANT_CHECKBOX_IGNOREPAUSE), CLang::GetString(IDS__DIALOG_ASSISTANT__IGNOREPAUSE       ));


   ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_SPIN_FIRST, UDM_SETRANGE, 0L, MAKELPARAM(maxTimeoutFirst, minTimeoutFirst));
   ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_SPIN_FIRST, UDM_SETPOS  , 0L, m_AssistantInfo.m_Timeout.m_iFirst);
   ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_SPIN_NEXT , UDM_SETRANGE, 0L, MAKELPARAM(maxTimeoutNext, minTimeoutNext));
   ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_SPIN_NEXT , UDM_SETPOS  , 0L, m_AssistantInfo.m_Timeout.m_iNext);


   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_STATIC_FIRST        );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_STATIC_NEXT         );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_STATIC_SECOND       );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_STATIC_MILISECOND   );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_SPIN_FIRST          );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_SPIN_NEXT           );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_CHECKBOX_AUTOSTART  );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_CHECKBOX_STOPWORK   );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_CHECKBOX_IGNOREPAUSE);

   CDialogMessageHook::InstallHook(m_hWnd);

   return TRUE;
}

#define CDialogAssistant__OnSpinChange(iVal, idControl, iMax) { \
   iVal = ::SendDlgItemMessage(m_hWnd, idControl, UDM_GETPOS, 0L, 0L); \
   if (iVal > iMax) { \
      iVal -= 0x10000; \
      ::SendDlgItemMessage(m_hWnd, idControl, UDM_SETPOS, 0L, iVal); \
   } \
}

void CDialogAssistant::OnCommand(HWND, int idControl, HWND hwndCtl, UINT codeNotify) {
   switch (idControl) {
   case IDC_ASSISTANT_EDIT_FIRST:
      if (codeNotify == EN_CHANGE) {
         CDialogAssistant__OnSpinChange(m_AssistantInfo.m_Timeout.m_iFirst, IDC_ASSISTANT_SPIN_FIRST, maxTimeoutFirst);
      }
      return;
   case IDC_ASSISTANT_EDIT_NEXT:
      if (codeNotify == EN_CHANGE) {
         CDialogAssistant__OnSpinChange(m_AssistantInfo.m_Timeout.m_iNext , IDC_ASSISTANT_SPIN_NEXT , maxTimeoutNext);
      }
      return;
   case IDOK:
      if (codeNotify == BN_CLICKED) {
         m_AssistantInfo.m_bAutoStart   = (BST_CHECKED == ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_CHECKBOX_AUTOSTART  , BM_GETCHECK, 0L, 0L));
         m_AssistantInfo.m_bStopWork    = (BST_CHECKED == ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_CHECKBOX_STOPWORK   , BM_GETCHECK, 0L, 0L));
         m_AssistantInfo.m_bIgnorePause = (BST_CHECKED == ::SendDlgItemMessage(m_hWnd, IDC_ASSISTANT_CHECKBOX_IGNOREPAUSE, BM_GETCHECK, 0L, 0L));

         GetFM2WinMain().SetAssistantInfo(m_AssistantInfo);
      }
   case IDCANCEL:
      if (codeNotify == BN_CLICKED) {
         ::SendMessage(m_hWnd, WM_CLOSE, 0L, 0L);
      }
      return;
   }
}

void CDialogAssistant::OnClose(HWND) {
   ::DestroyWindow(m_hWnd);
}

void CDialogAssistant::OnDestroy(HWND) {
   CDialogMessageHook::UninstallHook(m_hWnd);
   m_hWnd = NULL;
}

BOOL CDialogAssistant::OnEraseBkgnd(HWND, HDC hDC) {
   if (!GetFM2WinMain().GetSkin().m_bToAll)
   {
      return FALSE; // DefWindowProc(m_hWnd, WM_ERASEBKGND, (WPARAM)hDC, 0L);
   }
   return nsEraseBk::OnEraseBkgnd(m_hWnd, hDC, GetFM2WinMain().GetSkin().GetBkColor());
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
#else // _WTL_VER
////////////////////////////////////////////////////////////////////////////////////////////////////////

// modeless dialogs
HWND CDialogAssistant::Create(HWND hWndParent, LPARAM dwInitParam)
{
	ATLASSERT(m_hWnd == NULL);
	_Module.AddCreateWndData(&m_thunk.cd, this);
#ifdef _DEBUG
	m_bModal = false;
#endif //_DEBUG
	HWND hWnd = ::CreateDialogParam(_Module.GetResourceInstance(), CDialogAssistant::IDD(), hWndParent, (DLGPROC)CDialogAssistant::StartDialogProc, dwInitParam);
	ATLASSERT(hWnd == m_hWnd);
	return m_hWnd;
}

BOOL CDialogAssistant::OnInitDialog(HWND hwndFocus, LPARAM lParam) {

   DoDataExchange();




   m_AssistantInfo = GetFM2WinMain().GetAssistantInfo();

   SetWindowText(                                                  CLang::GetString(IDS__DIALOG_ASSISTANT                    ));
   ::SetWindowText(m_BtnOk.m_hWnd                                , CLang::GetString(IDS__OK                                  ));
   ::SetWindowText(GetDlgItem(IDC_ASSISTANT_STATIC_FIRST        ), CLang::GetString(IDS__DIALOG_ASSISTANT__TIMEOUT_USER_FIRST));
   ::SetWindowText(GetDlgItem(IDC_ASSISTANT_STATIC_NEXT         ), CLang::GetString(IDS__DIALOG_ASSISTANT__TIMEOUT_NEXT      ));
   ::SetWindowText(GetDlgItem(IDC_ASSISTANT_STATIC_SECOND       ), CLang::GetString(IDS__SECOND                              ));
   ::SetWindowText(GetDlgItem(IDC_ASSISTANT_STATIC_MILISECOND   ), CLang::GetString(IDS__MILISECOND                          ));
   ::SetWindowText(GetDlgItem(IDC_ASSISTANT_CHECKBOX_AUTOSTART  ), CLang::GetString(IDS__DIALOG_ASSISTANT__NEW_GAME_AUTOSTART));
   ::SetWindowText(GetDlgItem(IDC_ASSISTANT_CHECKBOX_STOPWORK   ), CLang::GetString(IDS__DIALOG_ASSISTANT__STOPWORK          ));
   ::SetWindowText(GetDlgItem(IDC_ASSISTANT_CHECKBOX_IGNOREPAUSE), CLang::GetString(IDS__DIALOG_ASSISTANT__IGNOREPAUSE       ));

   m_SpinFirst.SetRange(minTimeoutFirst, maxTimeoutFirst);
   m_SpinNext .SetRange(minTimeoutNext , maxTimeoutNext);
   m_SpinFirst.SetPos(m_AssistantInfo.m_Timeout.m_iFirst);
   m_SpinNext .SetPos(m_AssistantInfo.m_Timeout.m_iNext);

   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_STATIC_FIRST        );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_STATIC_NEXT         );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_STATIC_SECOND       );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_STATIC_MILISECOND   );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_SPIN_FIRST          );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_SPIN_NEXT           );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_CHECKBOX_AUTOSTART  );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_CHECKBOX_STOPWORK   );
   SETNEWWNDPROC(m_hWnd, IDC_ASSISTANT_CHECKBOX_IGNOREPAUSE);

   CDialogMessageHook::InstallHook(m_hWnd);

   return TRUE;
}

#define CDialogAssistant__OnSpinChange(iVal, spin, iMax) { \
   iVal = spin.GetPos(); \
   if(iVal > iMax) { \
      iVal -= 0x10000; \
      spin.SetPos(iVal); \
   } \
}
void CDialogAssistant::OnSpinChangeFirst(UINT /*wNotifyCode*/, int /*idControl*/, HWND hWndCtl) {
   if (m_SpinFirst.m_hWnd) CDialogAssistant__OnSpinChange(m_AssistantInfo.m_Timeout.m_iFirst, m_SpinFirst, maxTimeoutFirst);
}
void CDialogAssistant::OnSpinChangeNext (UINT /*wNotifyCode*/, int /*idControl*/, HWND hWndCtl) {
   if (m_SpinNext .m_hWnd) CDialogAssistant__OnSpinChange(m_AssistantInfo.m_Timeout .m_iNext, m_SpinNext , maxTimeoutNext);
}

void CDialogAssistant::OnCommand(UINT codeNotify, int idControl, HWND /*hwndCtl*/) {
   switch (idControl) {
   case IDOK:
      if (codeNotify == BN_CLICKED) {
         DoDataExchange(TRUE);
         GetFM2WinMain().SetAssistantInfo(m_AssistantInfo);
      }
   case IDCANCEL:
      if (codeNotify == BN_CLICKED) {
         SendMessage(WM_CLOSE, 0L, 0L);
      }
      return;
   }
}

void CDialogAssistant::OnClose() {
   DestroyWindow();
}

void CDialogAssistant::OnDestroy() {
   CDialogMessageHook::UninstallHook(m_hWnd);
}

BOOL CDialogAssistant::OnEraseBkgnd(HDC hdc) {
   if (!GetFM2WinMain().GetSkin().m_bToAll) {
      SetMsgHandled(FALSE);
      return FALSE;
   }
   return nsEraseBk::OnEraseBkgnd(m_hWnd, hdc, GetFM2WinMain().GetSkin().GetBkColor());
}

#endif // _WTL_VER
