////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "Skin.cpp"
//    "Change skin"
//    "Image/Color/Font/Text ..."
//    "Save Skin" ("InputText")
// Copyright (C) 2003-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////
//
// 2007.03.01-2007.03.02
//       (     )
//
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Skin.h"
#include "../FastMines2.h"
#include "../EraseBk.h"
#include "../Lang.h"
#include "./DialogMessageHook.h"
#include "./TemplateSelectImage.h"
#include "../OldVersion.h"
#include "../DynLoadLib.h"

////////////////////////////////////////////////////////////////////////////////
//                             global variables
////////////////////////////////////////////////////////////////////////////////
extern CFastMines2WinMain& GetFM2WinMain();

//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_IMAGE_MINE         , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_IMAGE_FLAG         , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_IMAGE_PAUSE        , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_IMAGE_BCKGRND      , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_IMAGE_BTNNEW       , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_IMAGE_BTNPAUSE     , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_COLOR_BCKGRND      , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_COLOR_TEXT         , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_TYPE_FONT          , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_BORDER             , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_SELECT             , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_SELECT2            , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL, GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_STATIC_PLACE              , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_STATIC_ALIGMENT           , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_TOP_LEFT            , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_TOP_CENTER          , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_TOP_RIGHT           , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_MIDDLE_LEFT         , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_MIDDLE_CENTER       , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT        , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_BOTTOM_LEFT         , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_BOTTOM_CENTER       , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT        , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_AS_IS               , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_UNIFORMLY           , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_STRETCH             , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_RADIO_TILE                , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_RESET              , GetFM2WinMain().GetSkin())
  WNDPROC_BUTTON(IDC_CHANGESKIN_BUTTON_FRAME              , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDOK                                     , GetFM2WinMain().GetSkin())
//WNDPROC_BUTTON(IDCANCEL                                 , GetFM2WinMain().GetSkin())
  WNDPROC_STATIC(IDC_CHANGESKIN_SPIN_VALUE                , GetFM2WinMain().GetSkin())
  WNDPROC_STATIC(IDC_CHANGESKIN_SPIN_PREVIEW              , GetFM2WinMain().GetSkin())

#define MAX_TIMER_PAUSE 10000

////////////////////////////////////////////////////////////////////////////////
//                          help functions
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//                          implementation CDialogChangeSkin
////////////////////////////////////////////////////////////////////////////////
#ifndef _WTL_VER

CDialogChangeSkin::CDialogChangeSkin() :
   m_hWnd(NULL),
   m_hWndSpinPreView(NULL),
#pragma warning(disable:4355) // 'this' : used in base member initializer list
   m_PreView(*this)
#pragma warning(default:4355)
{}

HWND CDialogChangeSkin::Create(HWND hWndParent) {
   return ::CreateDialogParam(::GetModuleHandle(NULL), CDialogChangeSkin::IDD(), hWndParent, (DLGPROC)CDialogChangeSkin::DialogProcThis, (LPARAM)this);
}

/*static*/ INT_PTR CALLBACK CDialogChangeSkin::DialogProcThis(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
   //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogChangeSkin::DialogProcThis: %s "), (LPCTSTR)CLogger::WindowMessage(uMsg));
   CDialogChangeSkin *This = NULL;
   if (uMsg == WM_INITDIALOG) {
      This = (CDialogChangeSkin*)lParam;
      if (This) {
         This->m_hWnd = hWnd;
         ::SetWindowUserData(hWnd, (LONG_PTR)This);
      }
   } else {
      This = (CDialogChangeSkin*)::GetWindowUserData(hWnd);
   }
   if (This) {
      return This->DialogProc(hWnd, uMsg, wParam, lParam);
   }
   return FALSE;
}

BOOL CDialogChangeSkin::OnInitDialog(HWND, HWND hwndFocus, LPARAM lParam) {
   m_BtnOk          .SubclassWindow(::GetDlgItem(m_hWnd, IDOK));
   m_BtnCancel      .SubclassWindow(::GetDlgItem(m_hWnd, IDCANCEL));
   m_BtnImgMine     .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_IMAGE_MINE));
   m_BtnImgFlag     .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_IMAGE_FLAG));
   m_BtnImgPause    .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_IMAGE_PAUSE));
   m_BtnImgBtnPause .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_IMAGE_BTNPAUSE));
   m_BtnImgBtnNew   .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_IMAGE_BTNNEW));
   m_BtnImgBkgrnd   .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_IMAGE_BCKGRND));
   m_BtnColorBkgrnd .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_COLOR_BCKGRND));
   m_BtnImgBorder   .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_BORDER));
   m_BtnImgColorText.SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_COLOR_TEXT));
   m_BtnImgTypeFont .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TYPE_FONT));
   m_BtnSelect      .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_SELECT));
   m_BtnSelect2     .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_SELECT2));
   m_BtnReset       .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_RESET));
   m_EditValueDescr .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_EDIT_VALUE_DESCRIPTION));
   m_EditValue      .SubclassWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_EDIT_VALUE));

   m_sizeDlgDef = ::GetWindowRect(m_hWnd);
   m_rcEditValDescr = ::ScreenToClient(m_hWnd, ::GetWindowRect(m_EditValueDescr.m_hWnd));
   m_rcEditVal      = ::ScreenToClient(m_hWnd, ::GetWindowRect(m_EditValue     .m_hWnd));
   m_rcSpinVal      = ::ScreenToClient(m_hWnd, ::GetWindowRect(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE)));

   ::SetWindowText(m_hWnd                                              , CLang::GetString(IDS__DIALOG_CHANGESKIN                                ));
   ::SetWindowText(m_BtnOk          .m_hWnd                            , CLang::GetString(IDS__OK                                               ));
   ::SetWindowText(m_BtnCancel      .m_hWnd                            , CLang::GetString(IDS__CANCEL                                           ));
   ::SetWindowText(m_BtnImgMine     .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_IMAGE_MINE        ));
   ::SetWindowText(m_BtnImgFlag     .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_IMAGE_FLAG        ));
   ::SetWindowText(m_BtnImgPause    .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_IMAGE_PAUSE       ));
   ::SetWindowText(m_BtnImgBtnPause .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_BUTTON_PAUSE      ));
   ::SetWindowText(m_BtnImgBtnNew   .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_BUTTON_GAME       ));
   ::SetWindowText(m_BtnImgBkgrnd   .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_IMAGE_BACKGROUND  ));
   ::SetWindowText(m_BtnColorBkgrnd .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_COLOR_BACKGROUND  ));
   ::SetWindowText(m_BtnImgBorder   .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_BORDER_COLOR_WIDTH));
   ::SetWindowText(m_BtnImgColorText.m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_CHARACTER_COLOR   ));
   ::SetWindowText(m_BtnImgTypeFont .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_FONT_TYPE         ));
   ::SetWindowText(m_BtnReset       .m_hWnd                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__RESET_TO_DEFAULT              ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_STATIC_PLACE   ), CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE_PLACEMENT               ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_STATIC_ALIGMENT), CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE_ALIGN                   ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_AS_IS    ), CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE__AS_IS                  ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_UNIFORMLY), CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE__UNIFORMLY              ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_STRETCH  ), CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE__STRETCH                ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TILE     ), CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE__TILE                   ));
   ::SetWindowText(m_EditValueDescr.m_hWnd                             , CLang::GetString(IDS__DIALOG_CHANGESKIN__WIDTH_BORDER                  ));

   m_Skin = GetFM2WinMain().GetSkin();
   if (CImage(m_Skin.m_ImgsPause.GetImg(m_Skin.m_ImgsPause.GetSize()-1)).Valid()) {
      //      
      m_Skin.m_ImgsPause.AddImg(CImageSerialize());
   }

   { //  
      RECTEX rc = ::ScreenToClient(m_hWnd, ::GetWindowRect(m_BtnImgMine.m_hWnd));
      rc.height(rc.height()-1);
      ::MoveWindow(m_BtnImgMine     .m_hWnd, rc                     , FALSE);
      const int k=-1;
      ::MoveWindow(m_BtnImgFlag     .m_hWnd, rc.moveY(rc.height()-k), FALSE);
      ::MoveWindow(m_BtnImgPause    .m_hWnd, rc.moveY(rc.height()-k), FALSE);
      ::MoveWindow(m_BtnImgBtnPause .m_hWnd, rc.moveY(rc.height()-k), FALSE);
      ::MoveWindow(m_BtnImgBtnNew   .m_hWnd, rc.moveY(rc.height()-k), FALSE);
      ::MoveWindow(m_BtnImgBkgrnd   .m_hWnd, rc.moveY(rc.height()-k), FALSE);
      ::MoveWindow(m_BtnColorBkgrnd .m_hWnd, rc.moveY(rc.height()-k), FALSE);
      ::MoveWindow(m_BtnImgBorder   .m_hWnd, rc.moveY(rc.height()-k), FALSE);
      ::MoveWindow(m_BtnImgColorText.m_hWnd, rc.moveY(rc.height()-k), FALSE);
      ::MoveWindow(m_BtnImgTypeFont .m_hWnd, rc.moveY(rc.height()-k), FALSE);
   }

   m_skinPart = eSkinImageMine;
   Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_IMAGE_MINE), BST_CHECKED);

   m_PreView.Create(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_FRAME), RECTEX());

   ReInitDialog();

 //SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_BUTTON_BORDER             );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL);
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_STATIC_PLACE              );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_STATIC_ALIGMENT           );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_LEFT            );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_CENTER          );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_RIGHT           );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_LEFT         );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_CENTER       );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT        );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_LEFT         );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_CENTER       );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT        );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_AS_IS               );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_UNIFORMLY           );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_STRETCH             );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_TILE                );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_BUTTON_FRAME              );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE                );
 //SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_SPIN_PREVIEW              ); //   !!!

   CDialogMessageHook::InstallHook(m_hWnd);

   return TRUE;
}

CImageSerialize CDialogChangeSkin::GetDefaultImage() {
   switch (m_skinPart) {
   case eSkinImageMine    : return CSkin().m_ImgMine;
   case eSkinImageFlag    : return CSkin().m_ImgFlag;
   case eSkinImagePause   : return CSkin().m_ImgsPause.GetImg(::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L));
   case eSkinImageBckgrnd : return CSkin().m_ImgBckgrnd;
   case eSkinImageBtnNew  : return CSkin().m_ImgBtnNew  [::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L)];
   case eSkinImageBtnPause: return CSkin().m_ImgBtnPause[::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L)];
   }
   return CImageSerialize();
}

CImageSerialize& CDialogChangeSkin::GetSkinImage() {
   switch (m_skinPart) {
   case eSkinImageMine    : return m_Skin.m_ImgMine;
   case eSkinImageFlag    : return m_Skin.m_ImgFlag;
   case eSkinImagePause   : return m_Skin.m_ImgsPause.GetImgRef(::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L));
   case eSkinImageBckgrnd : return m_Skin.m_ImgBckgrnd;
   case eSkinImageBtnNew  : return m_Skin.m_ImgBtnNew  [::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L)];
   case eSkinImageBtnPause: return m_Skin.m_ImgBtnPause[::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L)];
   }
   static CImageSerialize imgGarbage;
   return imgGarbage;
}

COLORREF CDialogChangeSkin::GetSkinColor(bool bBtnSelect2) {
   COLORREF color = CLR_INVALID;
   switch(m_skinPart) {
   case eSkinBorder:
      if (bBtnSelect2)
           color = m_Skin.m_Border.m_colorShadow;
      else color = m_Skin.m_Border.m_colorLight;
      break;
   case eSkinColorBckgrnd:
      color = m_Skin.GetBkColor();
      break;
   case eSkinColorText:
      {
         int val = ::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L);
         if (val) color = m_Skin.m_ColorText.m_colorOpen [val];
             else color = m_Skin.m_ColorText.m_colorClose[ 0 ];
      }
      break;
   }
   return color;
}

void CDialogChangeSkin::SetSkinColor(COLORREF color, bool bBtnSelect2) {
   switch(m_skinPart) {
   case eSkinBorder:
      if (bBtnSelect2)
           m_Skin.m_Border.m_colorShadow = color;
      else m_Skin.m_Border.m_colorLight  = color;
      break;
   case eSkinColorBckgrnd:
      m_Skin.SetBkColor(color);
      break;
   case eSkinColorText:
      {
         int val = ::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L);
         if (val) m_Skin.m_ColorText.m_colorOpen [val] = color;
             else m_Skin.m_ColorText.m_colorClose[ 0 ] = color;
      }
      break;
   }
}

void CDialogChangeSkin::InvalidateFrame() {
   RECTEX redraw = ::GetWindowRect(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_FRAME));
   redraw = ::ScreenToClient(m_hWnd, redraw);
   ::InvalidateRect(m_hWnd, &redraw, TRUE);
}

void CDialogChangeSkin::ReInitDialog() {
   if (m_hWndSpinPreView) {
      ::DestroyWindow(m_hWndSpinPreView);
      m_hWndSpinPreView = NULL;
   }

   switch (m_skinPart) {
   case eSkinImagePause:
      {
         static int iOffX = 140;
         ::SetWindowPos(m_hWnd, NULL, 0,0, m_sizeDlgDef.cx+iOffX, m_sizeDlgDef.cy, SWP_NOZORDER | SWP_NOMOVE);
         ::MoveWindow(m_EditValueDescr.m_hWnd                        , RECTEX(m_rcEditValDescr).moveX(iOffX).moveY(-55).height(95));
         ::MoveWindow(m_EditValue     .m_hWnd                        , RECTEX(m_rcEditVal     ).moveX(iOffX).moveY(-50));
         ::MoveWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE), RECTEX(m_rcSpinVal     ).moveX(iOffX).moveY(-50));
      }
      break;
   default:
      ::SetWindowPos(m_hWnd, NULL, 0,0, m_sizeDlgDef.cx, m_sizeDlgDef.cy, SWP_NOZORDER | SWP_NOMOVE);
      ::MoveWindow(m_EditValueDescr.m_hWnd                        , m_rcEditValDescr);
      ::MoveWindow(m_EditValue     .m_hWnd                        , m_rcEditVal     );
      ::MoveWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE), m_rcSpinVal     );
   }

   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_TRANSPARENT));
   switch (m_skinPart) {
   case eSkinImageMine    :
   case eSkinImageFlag    :
   case eSkinImageBtnNew  :
   case eSkinImageBtnPause:
   case eSkinImageBckgrnd : ::SetWindowText(m_BtnSelect     .m_hWnd                                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_IMAGE       )); break;
   case eSkinImagePause   : ::SetWindowText(m_BtnSelect     .m_hWnd                                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_IMAGE       ));
                            ::SetWindowText(m_EditValueDescr.m_hWnd                                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__TIMER_PAUSE        ));
   case eSkinTypeFont     : ::SetWindowText(m_BtnSelect     .m_hWnd                                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_FONT        )); break;
   case eSkinColorBckgrnd : ::SetWindowText(::GetDlgItem(    m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_APPLY_TO_ALL));
   case eSkinColorText    : ::SetWindowText(m_BtnSelect     .m_hWnd                                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_COLOR       )); break;
   case eSkinBorder       : ::SetWindowText(m_BtnSelect     .m_hWnd                                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_LIGHT_COLOR ));
                            ::SetWindowText(m_BtnSelect2    .m_hWnd                                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_SHADOW_COLOR));
                            ::SetWindowText(m_EditValueDescr.m_hWnd                                            , CLang::GetString(IDS__DIALOG_CHANGESKIN__WIDTH_BORDER       )); break;
   }

   switch (m_skinPart) {
   case eSkinImageMine:
   case eSkinImageFlag:
   case eSkinImagePause:
   case eSkinImageBtnPause:
   case eSkinImageBtnNew:
   case eSkinImageBckgrnd:
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_STATIC_PLACE              ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_STATIC_ALIGMENT           ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_LEFT            ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_CENTER          ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_RIGHT           ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_LEFT         ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_CENTER       ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT        ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_LEFT         ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_CENTER       ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT        ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_AS_IS               ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_UNIFORMLY           ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_STRETCH             ), SW_SHOW);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TILE                ), SW_SHOW);

      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_SELECT2            ), SW_HIDE);
      ::ShowWindow(m_EditValueDescr.m_hWnd                                        , (m_skinPart == eSkinImagePause) ? SW_SHOW : SW_HIDE);
      ::ShowWindow(m_EditValue     .m_hWnd                                        , (m_skinPart == eSkinImagePause) ? SW_SHOW : SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE                ), (m_skinPart == eSkinImagePause) ? SW_SHOW : SW_HIDE);
      break;
   case eSkinColorBckgrnd:
   case eSkinBorder:
   case eSkinColorText:
   case eSkinTypeFont:
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_STATIC_PLACE              ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_STATIC_ALIGMENT           ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_LEFT            ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_CENTER          ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_RIGHT           ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_LEFT         ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_CENTER       ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT        ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_LEFT         ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_CENTER       ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT        ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_AS_IS               ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_UNIFORMLY           ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_STRETCH             ), SW_HIDE);
      ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TILE                ), SW_HIDE);

      switch (m_skinPart) {
      case eSkinColorBckgrnd:
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), SW_SHOW);
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_SELECT2            ), SW_HIDE);
         ::ShowWindow(m_EditValueDescr.m_hWnd                                        , SW_HIDE);
         ::ShowWindow(m_EditValue     .m_hWnd                                        , SW_HIDE);
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE                ), SW_HIDE);
         break;
      case eSkinBorder:
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), SW_HIDE);
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_SELECT2            ), SW_SHOW);
         ::ShowWindow(m_EditValueDescr.m_hWnd                                        , SW_SHOW);
         ::ShowWindow(m_EditValue     .m_hWnd                                        , SW_SHOW);
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE                ), SW_SHOW);
         break;
      case eSkinColorText:
      case eSkinTypeFont:
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), SW_HIDE);
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_SELECT2            ), SW_HIDE);
         ::ShowWindow(m_EditValueDescr.m_hWnd                                        , SW_HIDE);
         ::ShowWindow(m_EditValue     .m_hWnd                                        , SW_HIDE);
         ::ShowWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE                ), SW_HIDE);
         break;
      }
      break;
   }

   ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_AS_IS    ), TRUE);
   ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_UNIFORMLY), TRUE);
   ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_STRETCH  ), TRUE);
   ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TILE     ), TRUE);
   ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), TRUE);

   RECTEX rc(::GetWindowRect(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_FRAME)));
   SIZE sizeOut = rc.size();
   SIZE sizeIn = {10,10};
   switch (m_skinPart) {
   case eSkinImagePause  :
   case eSkinImageBckgrnd:
   case eSkinColorBckgrnd: sizeIn = GetFM2WinMain().GetSizeMosaicWindow();
   }
   rc = FindInnerRect(sizeIn, sizeOut);
   ::MoveWindow(m_PreView.m_hWnd, rc);

   int nUpper, nLower, nPos;
   switch (m_skinPart) {
   case eSkinBorder:
      ::SendDlgItemMessage(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE, UDM_SETRANGE, 0L, MAKELPARAM(10, 1));
      ::SendDlgItemMessage(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE, UDM_SETPOS  , 0L, m_Skin.m_Border.m_iWidth);
      break;
   case eSkinImageBtnPause:
   case eSkinImageBtnNew  : nPos = 0        ; nLower = 0              ; nUpper = 3         ; break;
   case eSkinColorText    : nPos = CCell::_1; nLower = CCell::_Unknown; nUpper = CCell::_21; break;
   case eSkinImagePause   : nPos = 0        ; nLower = 0              ; nUpper = m_Skin.m_ImgsPause.GetSize()-1;
      ::SendDlgItemMessage(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE, UDM_SETRANGE, 0L, MAKELPARAM(MAX_TIMER_PAUSE, 1));
      ::SendDlgItemMessage(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE, UDM_SETPOS  , 0L, m_Skin.m_iTimerPause);
      break;
   case eSkinColorBckgrnd :
      Button_SetCheck(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), m_Skin.m_bToAll ? BST_CHECKED : BST_UNCHECKED);
      break;
   }

   switch (m_skinPart) {
   case eSkinImageBtnPause:
   case eSkinImageBtnNew:
   case eSkinColorText:
   case eSkinImagePause: 
      m_hWndSpinPreView = ::CreateUpDownControl(
         WS_CHILD | WS_VISIBLE | UDS_ALIGNRIGHT | UDS_SETBUDDYINT,
         0,0,20,30,
         ::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_FRAME),
         IDC_CHANGESKIN_SPIN_PREVIEW,
         ::GetModuleHandle(NULL),
         m_PreView.m_hWnd,
         nUpper, nLower, nPos);
      defWndProc_IDC_CHANGESKIN_SPIN_PREVIEW() = ::SetWindowProc(m_hWndSpinPreView, newWndProc_IDC_CHANGESKIN_SPIN_PREVIEW);
   }

   AcceptImage();

   InvalidateFrame();
}

#define CDialogChangeSkin__OnSpinChange(iVal, idControl, iMax) { \
   LRESULT lRes = ::SendDlgItemMessage(m_hWnd, (idControl), UDM_GETPOS, 0L, 0L); \
   (iVal) = min(LOWORD(lRes), (iMax)); \
   ::SendDlgItemMessage(m_hWnd, (idControl), UDM_SETPOS, 0L, (iVal)); \
}

void CDialogChangeSkin::OnCommand(HWND, int idControl, HWND hWndCtl, UINT codeNotify) {
   //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogChangeSkin::OnCommand: idControl=%i hWndCtl=0x%08X codeNotify=%i "), idControl, hWndCtl, codeNotify);
   switch (idControl) {
   case IDC_CHANGESKIN_BUTTON_IMAGE_MINE    :
   case IDC_CHANGESKIN_BUTTON_IMAGE_FLAG    :
   case IDC_CHANGESKIN_BUTTON_IMAGE_PAUSE   :
   case IDC_CHANGESKIN_BUTTON_IMAGE_BTNPAUSE:
   case IDC_CHANGESKIN_BUTTON_IMAGE_BTNNEW  :
   case IDC_CHANGESKIN_BUTTON_IMAGE_BCKGRND :
   case IDC_CHANGESKIN_BUTTON_COLOR_BCKGRND :
   case IDC_CHANGESKIN_BUTTON_BORDER        :
   case IDC_CHANGESKIN_BUTTON_COLOR_TEXT    :
   case IDC_CHANGESKIN_BUTTON_TYPE_FONT     :
      if (codeNotify == BN_CLICKED) {
         m_skinPart = ESkinPart(idControl-IDC_CHANGESKIN_BUTTON_IMAGE_MINE);
         ReInitDialog();
      }
      return;
   case IDC_CHANGESKIN_EDIT_VALUE:
      if (codeNotify == EN_CHANGE) {
         switch (m_skinPart) {
         case eSkinImagePause: CDialogChangeSkin__OnSpinChange(m_Skin.m_iTimerPause    , IDC_CHANGESKIN_SPIN_VALUE, MAX_TIMER_PAUSE); break;
         case eSkinBorder    : CDialogChangeSkin__OnSpinChange(m_Skin.m_Border.m_iWidth, IDC_CHANGESKIN_SPIN_VALUE, 10             ); break;
         }
         ::InvalidateRect(m_PreView.m_hWnd, NULL, TRUE);
      }
      return;
   case IDC_CHANGESKIN_BUTTON_SELECT2:
   case IDC_CHANGESKIN_BUTTON_SELECT:
      if (codeNotify == BN_CLICKED) {
         switch (m_skinPart) {
         case eSkinImageMine    :
         case eSkinImageFlag    :
         case eSkinImagePause   :
         case eSkinImageBtnNew  :
         case eSkinImageBtnPause:
         case eSkinImageBckgrnd : {
               CDialogTemplateSelectImage dlgTmplSI(
                  m_hWnd,
                  NULL,
                  GetSkinImage().m_strPath.IsEmpty() ? ::GetCurrentDirectory() : GetSkinImage().m_strPath, 
                  CLang::GetString(IDS__DIALOG_CHANGESKIN__OPENFILENAME_TITLE_OPEN_IMAGE),
                  NULL);
               if (IDOK == dlgTmplSI.DoModal()) {
                  GetSkinImage().m_strPath = dlgTmplSI.m_strFile+dlgTmplSI.m_strResTypeAndName;
                  AcceptImage();
                  if (CImage(GetSkinImage()).Valid() && (m_skinPart==eSkinImagePause)) {
                     //         ,     
                     //    (    ).
                     if ((m_Skin.m_ImgsPause.GetSize()-1) == ::SendMessage(m_hWndSpinPreView, UDM_GETPOS, 0L, 0L)) {
                        m_Skin.m_ImgsPause.AddImg(CImageSerialize());
                        ::SendMessage(m_hWndSpinPreView, UDM_SETRANGE, 0L, MAKELPARAM(m_Skin.m_ImgsPause.GetSize()-1, 0)); 
                     }
                  }
               }
            }
            break;
         case eSkinBorder      :
         case eSkinColorBckgrnd:
         case eSkinColorText   :
            {
               static COLORREF colors[16] = {
                  0x000000, 0x0000FF, 0x00FF00, 0x00FFFF, 0xFF0000, 0xFF00FF, 0xFFFF00, 0xFFFFFF,
                  0xFFF000, 0x00007F, 0x007F00, 0x007F7F, 0x7F0000, 0x7F007F, 0x7F7F00, 0x7F7F7F
               };
               CHOOSECOLOR sChooseColor;
               sChooseColor.lStructSize  = sizeof(CHOOSECOLOR);
               sChooseColor.hwndOwner    = m_hWnd;
               sChooseColor.hInstance    = (HWND)::GetModuleHandle(NULL);
               sChooseColor.rgbResult    = GetSkinColor(idControl == IDC_CHANGESKIN_BUTTON_SELECT2);
               sChooseColor.lpCustColors = colors;
               sChooseColor.Flags        = CC_RGBINIT | CC_FULLOPEN | CC_SOLIDCOLOR;
             //sChooseColor.lCustData;
             //sChooseColor.lpfnHook;
             //sChooseColor.lpTemplateName;
               if (::ChooseColor(&sChooseColor)) {
                  SetSkinColor(sChooseColor.rgbResult, (idControl == IDC_CHANGESKIN_BUTTON_SELECT2));
               }
            }
            break;
         case eSkinTypeFont:
            {
               CHOOSEFONT sChooseFont;
               LOGFONT LogFont = m_Skin.m_Font;
               sChooseFont.lStructSize = sizeof(CHOOSEFONT);
               sChooseFont.hwndOwner   = m_hWnd;
               sChooseFont.hDC         = NULL;
               sChooseFont.lpLogFont   = &LogFont;
               sChooseFont.iPointSize  = 0;
               sChooseFont.Flags       = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;// CF_BOTH | CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT | CF_NOSCRIPTSEL | CF_NOSTYLESEL | CF_NOSIZESEL | CF_NOVERTFONTS | CF_SCREENFONTS | CF_SELECTSCRIPT;// | CF_LIMITSIZE;
             //sChooseFont.rgbColors   = 0;
             //sChooseFont.lCustData
             //sChooseFont.lpfnHook
             //sChooseFont.lpTemplateName
               sChooseFont.hInstance   = ::GetModuleHandle(NULL);
             //sChooseFont.lpszStyle
               sChooseFont.nFontType   = SCREEN_FONTTYPE;
             //sChooseFont.___MISSING_ALIGNMENT__
             //sChooseFont.nSizeMin
             //sChooseFont.nSizeMax
               if (::ChooseFont(&sChooseFont)) 
                  m_Skin.m_Font = LogFont;
            }
            break;
         }
         ::InvalidateRect(m_PreView.m_hWnd, NULL, TRUE);
      }
      return;
   case IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL:
      if (codeNotify == BN_CLICKED) {
         BOOL bCheck = (BST_CHECKED == Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL)));
         if (m_skinPart == eSkinColorBckgrnd) {
            m_Skin.m_bToAll = bCheck;
         } else {
            GetSkinImage().m_bTransparent = bCheck;
         }
         if (m_skinPart == eSkinColorBckgrnd) {
            ::InvalidateRect(m_hWnd, NULL, TRUE);
         } else {
            ::InvalidateRect(m_PreView.m_hWnd, NULL, TRUE);
         }
      }
      return;
   case IDC_CHANGESKIN_RADIO_TOP_LEFT     :
   case IDC_CHANGESKIN_RADIO_TOP_CENTER   :
   case IDC_CHANGESKIN_RADIO_TOP_RIGHT    :
   case IDC_CHANGESKIN_RADIO_MIDDLE_LEFT  :
   case IDC_CHANGESKIN_RADIO_MIDDLE_CENTER:
   case IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT :
   case IDC_CHANGESKIN_RADIO_BOTTOM_LEFT  :
   case IDC_CHANGESKIN_RADIO_BOTTOM_CENTER:
   case IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT :
   case IDC_CHANGESKIN_RADIO_AS_IS        :
   case IDC_CHANGESKIN_RADIO_UNIFORMLY    :
   case IDC_CHANGESKIN_RADIO_STRETCH      :
   case IDC_CHANGESKIN_RADIO_TILE         :
      if (codeNotify == BN_CLICKED) {
         switch (idControl) {
         case IDC_CHANGESKIN_RADIO_TOP_LEFT     : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceTop    | CImg::ePlaceLeft  ; break;
         case IDC_CHANGESKIN_RADIO_TOP_CENTER   : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceTop    | CImg::ePlaceCenter; break;
         case IDC_CHANGESKIN_RADIO_TOP_RIGHT    : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceTop    | CImg::ePlaceRight ; break;
         case IDC_CHANGESKIN_RADIO_MIDDLE_LEFT  : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceMiddle | CImg::ePlaceLeft  ; break;
         case IDC_CHANGESKIN_RADIO_MIDDLE_CENTER: GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceMiddle | CImg::ePlaceCenter; break;
         case IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceMiddle | CImg::ePlaceRight ; break;
         case IDC_CHANGESKIN_RADIO_BOTTOM_LEFT  : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceBottom | CImg::ePlaceLeft  ; break;
         case IDC_CHANGESKIN_RADIO_BOTTOM_CENTER: GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceBottom | CImg::ePlaceCenter; break;
         case IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceBottom | CImg::ePlaceRight ; break;
         case IDC_CHANGESKIN_RADIO_AS_IS        : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x0F) | CImg::ePlaceAsIs     ; break;
         case IDC_CHANGESKIN_RADIO_UNIFORMLY    : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x0F) | CImg::ePlaceUniformly; break;
         case IDC_CHANGESKIN_RADIO_STRETCH      : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x0F) | CImg::ePlaceStretch  ; break;
         case IDC_CHANGESKIN_RADIO_TILE         : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x0F) | CImg::ePlaceTile     ; break;
         }
         AcceptImage();
         ::InvalidateRect(m_PreView.m_hWnd, NULL, TRUE);
      }
      return;
   case IDC_CHANGESKIN_BUTTON_RESET:
      GetSkinImage() = GetDefaultImage();
      switch (m_skinPart) {
      case eSkinColorBckgrnd : m_Skin.SetBkColor  ( CSkin().GetBkColor());
                               m_Skin.m_bToAll    = CSkin().m_bToAll     ; break;
      case eSkinBorder       : m_Skin.m_Border    = CSkin().m_Border     ; break;
      case eSkinColorText    : m_Skin.m_ColorText = CSkin().m_ColorText  ; break;
      case eSkinTypeFont     : m_Skin.m_Font      = CSkin().m_Font       ; break;
      }

      AcceptImage();

      switch (m_skinPart) {
      case eSkinBorder       : ::SendDlgItemMessage(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE, UDM_SETPOS, 0L, m_Skin.m_Border.m_iWidth); break;
      case eSkinColorBckgrnd : ::SendDlgItemMessage(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL, BM_SETCHECK, (m_Skin.m_bToAll ? BST_CHECKED : BST_UNCHECKED), 0L);
                               ::InvalidateRect(m_hWnd, NULL, TRUE);
                               break;
      }
      ::InvalidateRect(m_PreView.m_hWnd, NULL, TRUE);
      return;
   case IDOK:
      if (codeNotify == BN_CLICKED) {
         GetFM2WinMain().SetSkin(m_Skin);
      }
   case IDCANCEL:
      if (codeNotify == BN_CLICKED) {
         ::SendMessage(m_hWnd, WM_CLOSE, 0L, 0L);
      }
      return;
   }
}

void CDialogChangeSkin::OnClose(HWND){
   ::DestroyWindow(m_hWnd);
}

void CDialogChangeSkin::OnDestroy(HWND) {
   CDialogMessageHook::UninstallHook(m_hWnd);
   m_hWnd = NULL;
   if (m_hWndSpinPreView) {
      ::DestroyWindow(m_hWndSpinPreView); m_hWndSpinPreView = NULL;
   }
}

BOOL CDialogChangeSkin::OnEraseBkgnd(HWND, HDC hDC) {
 //if (!GetFM2WinMain().GetSkin().m_bToAll)
   if (!m_Skin.m_bToAll) {
      return FALSE;
   }
 //return nsEraseBk::OnEraseBkgnd(m_hWnd, hDC, GetFM2WinMain().GetSkin().GetBkColor());
   return nsEraseBk::OnEraseBkgnd(m_hWnd, hDC, m_Skin.GetBkColor());
}

void CDialogChangeSkin::AcceptImage() {
   switch (m_skinPart) {
   case eSkinImageMine    :
   case eSkinImageFlag    :
   case eSkinImageBtnNew  :
   case eSkinImageBtnPause:
   case eSkinImagePause   :
   case eSkinImageBckgrnd :
      {
         CImg::EImageType eType = CImage(GetSkinImage()).GetImageType();
         BOOL bImg = (eType != CImg::eImageUnk);
         BOOL bAlign = bImg && (((GetSkinImage().m_Place&0x30)==CImg::ePlaceAsIs) || ((GetSkinImage().m_Place&0x30)==CImg::ePlaceUniformly));

         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_STATIC_PLACE              ), bImg);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_STATIC_ALIGMENT           ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL), bImg && (eType == CImg::eImageBMP));

         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_LEFT            ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_CENTER          ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_RIGHT           ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_LEFT         ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_CENTER       ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT        ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_LEFT         ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_CENTER       ), bAlign);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT        ), bAlign);

         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_AS_IS               ), bImg);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_UNIFORMLY           ), bImg);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_STRETCH             ), bImg);
         ::EnableWindow(::GetDlgItem(m_hWnd, IDC_CHANGESKIN_RADIO_TILE                ), bImg);

         if (bImg) {
            #define SetCheck(ID_Control, bCheck) Button_SetCheck(::GetDlgItem(m_hWnd, ID_Control), bCheck ? BST_CHECKED : BST_UNCHECKED);

            SetCheck(IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL, GetSkinImage().m_bTransparent);

            SetCheck(IDC_CHANGESKIN_RADIO_TOP_LEFT            , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceTop    | CImg::ePlaceLeft  ));
            SetCheck(IDC_CHANGESKIN_RADIO_TOP_CENTER          , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceTop    | CImg::ePlaceCenter));
            SetCheck(IDC_CHANGESKIN_RADIO_TOP_RIGHT           , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceTop    | CImg::ePlaceRight ));
            SetCheck(IDC_CHANGESKIN_RADIO_MIDDLE_LEFT         , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceMiddle | CImg::ePlaceLeft  ));
            SetCheck(IDC_CHANGESKIN_RADIO_MIDDLE_CENTER       , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceMiddle | CImg::ePlaceCenter));
            SetCheck(IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT        , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceMiddle | CImg::ePlaceRight ));
            SetCheck(IDC_CHANGESKIN_RADIO_BOTTOM_LEFT         , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceBottom | CImg::ePlaceLeft  ));
            SetCheck(IDC_CHANGESKIN_RADIO_BOTTOM_CENTER       , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceBottom | CImg::ePlaceCenter));
            SetCheck(IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT        , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceBottom | CImg::ePlaceRight ));

            SetCheck(IDC_CHANGESKIN_RADIO_AS_IS               , (GetSkinImage().m_Place & 0x30)==CImg::ePlaceAsIs);
            SetCheck(IDC_CHANGESKIN_RADIO_UNIFORMLY           , (GetSkinImage().m_Place & 0x30)==CImg::ePlaceUniformly);
            SetCheck(IDC_CHANGESKIN_RADIO_STRETCH             , (GetSkinImage().m_Place & 0x30)==CImg::ePlaceStretch);
            SetCheck(IDC_CHANGESKIN_RADIO_TILE                , (GetSkinImage().m_Place & 0x30)==CImg::ePlaceTile);
            #undef SetCheck
         }
      }
   }
}

////////////////////////////////////////////////////////////////////////////////
//                          implementation CWinSkinPreView
////////////////////////////////////////////////////////////////////////////////
CDialogChangeSkin::CWinSkinPreView::CWinSkinPreView(CDialogChangeSkin &SkinDialog) :
   m_hWnd(NULL),
   m_SkinDialog(SkinDialog)
{
   static WNDCLASSEX wc = {
      sizeof(WNDCLASSEX),                 // UINT        cbSize;
      0,                                  // UINT        style;
      WndProcThis,                        // WNDPROC     lpfnWndProc;
      0,                                  // int         cbClsExtra;
      0,                                  // int         cbWndExtra;
      ::GetModuleHandle(NULL),            // HINSTANCE   hInstance;
      NULL,                               // HICON       hIcon;
      ::LoadCursor(NULL, IDC_ARROW),      // HCURSOR     hCursor;
      ::GetSysColorBrush(COLOR_BTNFACE),  // HBRUSH      hbrBackground;
      NULL,                               // LPCTSTR     lpszMenuName;
      CWinSkinPreView::GetWindowClass(),     // LPCTSTR     lpszClassName;
      NULL                                // HICON       hIconSm;
   };
   static ATOM atom = ::RegisterClassEx(&wc);
}

BOOL CDialogChangeSkin::CWinSkinPreView::Create(HWND hWndParent, const RECT &rc) {
   m_hWnd = ::CreateWindowEx(
      0, CWinSkinPreView::GetWindowClass(),
      NULL, WS_CHILD | WS_VISIBLE | WS_DLGFRAME,
      rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top,
      hWndParent, NULL, ::GetModuleHandle(NULL), this);
   return !!m_hWnd;
}

void CDialogChangeSkin::CWinSkinPreView::OnSetText(HWND, LPCTSTR szText) {
   //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogChangeSkin::CWinSkinPreView::OnSetText: szText=[%s]"), szText);
   FORWARD_WM_SETTEXT(m_hWnd, szText, ::DefWindowProc);
   ::InvalidateRect(m_hWnd, NULL, TRUE);
   m_SkinDialog.AcceptImage();
}

BOOL CDialogChangeSkin::CWinSkinPreView::OnEraseBkgnd(HWND, HDC hDC) {
   return FALSE;
}

void CDialogChangeSkin::CWinSkinPreView::OnPaint(HWND) {
   PAINTSTRUCT PaintStruct;
   HDC hDC = ::BeginPaint(m_hWnd, &PaintStruct);
   RECT Rect; ::GetClientRect(m_hWnd, &Rect);

   HBITMAP hBmp = ::CreateCompatibleBitmap(hDC, Rect.right,Rect.bottom);

   HDC hCDC = ::CreateCompatibleDC(hDC);
   HGDIOBJ hOldBmp = ::SelectObject(hCDC, hBmp);
   {
      HBRUSH hBrushNew;
      switch (m_SkinDialog.m_skinPart) {
      case eSkinImageBtnNew  :
      case eSkinImageBtnPause:
         if (!m_SkinDialog.m_Skin.m_bToAll) {
            hBrushNew = ::CreateSolidBrush(::GetSysColor(COLOR_BTNFACE));
            break;
         }
      default:
         hBrushNew = ::CreateSolidBrush(m_SkinDialog.m_Skin.GetBkColor());
      }
      HGDIOBJ hBrushOld = ::SelectObject(hCDC, hBrushNew);
      ::PatBlt(hCDC, 0,0, Rect.right,Rect.bottom, PATCOPY);
      ::SelectObject(hCDC, hBrushOld);
      ::DeleteObject(hBrushNew);
   }
   switch (m_SkinDialog.m_skinPart) {
   case eSkinImageBtnNew  :
   case eSkinImageBtnPause:
   case eSkinImageMine    :
   case eSkinImageFlag    :
   case eSkinImagePause   :
   case eSkinImageBckgrnd :
      CImage(m_SkinDialog.GetSkinImage()).Draw(hCDC, Rect);
      break;
   case eSkinBorder     :
      {
         float a = toFLOAT(Rect.right)*4/10;
         float h = a*(float)sqrt(3.)/2;
         float c = toFLOAT(Rect.right)/2; // center
         POINT p[6] = {{toINT(c  ),toINT(c-a  )},
                       {toINT(c+h),toINT(c-a/2)},
                       {toINT(c+h),toINT(c+a/2)},
                       {toINT(c  ),toINT(c+a  )},
                       {toINT(c-h),toINT(c+a/2)},
                       {toINT(c-h),toINT(c-a/2)}};
         HPEN    hPenNew = ::CreatePen(PS_SOLID, m_SkinDialog.m_Skin.m_Border.m_iWidth, m_SkinDialog.m_Skin.m_Border.m_colorShadow);
         HGDIOBJ hPenOld = ::SelectObject(hCDC, hPenNew);
         ::MoveToEx(hCDC, p[0].x, p[0].y, NULL);
         ::LineTo  (hCDC, p[1].x, p[1].y);
         ::LineTo  (hCDC, p[2].x, p[2].y);
         ::LineTo  (hCDC, p[3].x, p[3].y);
         ::SelectObject(hCDC, hPenOld);
         ::DeleteObject(hPenNew);
         hPenNew = ::CreatePen(PS_SOLID, m_SkinDialog.m_Skin.m_Border.m_iWidth, m_SkinDialog.m_Skin.m_Border.m_colorLight);
         ::SelectObject(hCDC, hPenNew);
         ::LineTo  (hCDC, p[4].x, p[4].y);
         ::LineTo  (hCDC, p[5].x, p[5].y);
         ::LineTo  (hCDC, p[0].x, p[0].y);
         ::SelectObject(hCDC, hPenOld);
         ::DeleteObject(hPenNew);
      }
      break;
   case eSkinColorText:
      {
         COLORREF clr = m_SkinDialog.GetSkinColor(false);
         ::SetTextColor(hCDC, clr);
         ::SetBkMode   (hCDC, TRANSPARENT);
         ::GetClientRect(m_hWnd, &Rect);
         m_SkinDialog.m_Skin.m_Font.lfHeight = Rect.bottom;
         HFONT   hFontNew = ::CreateFontIndirect(&m_SkinDialog.m_Skin.m_Font);
         HGDIOBJ hFontOld = ::SelectObject(hCDC, hFontNew);
         TCHAR const *szCaption;
         int iVal = ::SendMessage(m_SkinDialog.m_hWndSpinPreView, UDM_GETPOS, 0L, 0L);
         if (iVal) {
            szCaption = CCell::GetCaptionOpen((CCell::EOpen)iVal);
         } else {
            szCaption = CCell::GetCaptionClose(CCell::_Unknown);
         }
         ::DrawText(hCDC, szCaption, -1, &Rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
         ::SelectObject(hCDC, hFontOld);
         ::DeleteObject(hFontNew);
      }
      break;
   case eSkinTypeFont:
      {
         TCHAR str [] = _T("\n\nFastMines - best\nMinesweeper clone!\n\n0 1 2 3 4 5 6 7 8 9 ?");
         TCHAR str1[] = _T("FastMines - best");
         TCHAR str2[] = _T("Minesweeper clone!");
         TCHAR str3[] = _T("0 1 2 3 4 5 6 7 8 9 ?");
         SIZE size1, size2, size3;

         ::SetBkMode   (hCDC, TRANSPARENT);
         ::SetTextColor(hCDC, RGB(0, 0, 0));

         ::GetClientRect(m_hWnd, &Rect);
         HFONT   hFontNew = NULL;
         HGDIOBJ hFontOld = NULL;         
         m_SkinDialog.m_Skin.m_Font.lfHeight = 0;
         do {
            m_SkinDialog.m_Skin.m_Font.lfHeight++;
            hFontNew = ::CreateFontIndirect(&m_SkinDialog.m_Skin.m_Font);
            hFontOld = ::SelectObject(hCDC, hFontNew);

            ::GetTextExtentPoint32(hCDC, str1, lstrlen(str1), &size1);
            ::GetTextExtentPoint32(hCDC, str2, lstrlen(str2), &size2);
            ::GetTextExtentPoint32(hCDC, str3, lstrlen(str3), &size3);

            ::SelectObject(hCDC, hFontOld);
            ::DeleteObject(hFontNew);
         } while (max(max(size1.cx, size2.cx), size3.cx) < (Rect.right-Rect.left));
         m_SkinDialog.m_Skin.m_Font.lfHeight--;
         hFontNew = ::CreateFontIndirect(&m_SkinDialog.m_Skin.m_Font);
         hFontOld = ::SelectObject(hCDC, hFontNew);
         ::DrawText(hCDC, str, -1, &Rect, DT_CENTER); // ::ExtTextOut(hCDC, 0,0, ETO_CLIPPED, &Rect, str1, strlen(str1), NULL);
         ::SelectObject(hCDC, hFontOld);
         ::DeleteObject(hFontNew);
      }
      break;
   }
   ::BitBlt(hDC, Rect, hCDC, SRCCOPY);
   ::SelectObject(hCDC, hOldBmp);
   ::DeleteDC(hCDC);
   ::DeleteObject(hBmp);
   ::EndPaint(m_hWnd, &PaintStruct);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
#else // _WTL_VER
////////////////////////////////////////////////////////////////////////////////////////////////////////

CDialogChangeSkin::CDialogChangeSkin() :
#pragma warning(disable:4355) // 'this' : used in base member initializer list
   m_PreView(*this)
#pragma warning(default:4355)
{}

// modeless dialogs
HWND CDialogChangeSkin::Create(HWND hWndParent, LPARAM dwInitParam)
{
	ATLASSERT(m_hWnd == NULL);
	_Module.AddCreateWndData(&m_thunk.cd, this);
#ifdef _DEBUG
	m_bModal = false;
#endif //_DEBUG
	HWND hWnd = ::CreateDialogParam(_Module.GetResourceInstance(), CDialogChangeSkin::IDD(), hWndParent, (DLGPROC)CDialogChangeSkin::StartDialogProc, dwInitParam);
	ATLASSERT(hWnd == m_hWnd);
	return m_hWnd;
}

BOOL CDialogChangeSkin::OnInitDialog(HWND hwndFocus, LPARAM lParam) {









   DoDataExchange();








   m_sizeDlgDef = ::GetWindowRect(m_hWnd);
   m_rcEditValDescr = ::ScreenToClient(m_hWnd, ::GetWindowRect(m_EditValueDescr.m_hWnd));
   m_rcEditVal      = ::ScreenToClient(m_hWnd, ::GetWindowRect(m_EditValue     .m_hWnd));
   m_rcSpinVal      = ::ScreenToClient(m_hWnd, ::GetWindowRect(m_SpinValue     .m_hWnd));

                            SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN                                ));
   m_BtnOk                 .SetWindowText(CLang::GetString(IDS__OK                                               ));
   m_BtnCancel             .SetWindowText(CLang::GetString(IDS__CANCEL                                           ));
   m_BtnImgMine            .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_IMAGE_MINE        ));
   m_BtnImgFlag            .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_IMAGE_FLAG        ));
   m_BtnImgPause           .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_IMAGE_PAUSE       ));
   m_BtnImgBtnPause        .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_BUTTON_PAUSE      ));
   m_BtnImgBtnNew          .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_BUTTON_GAME       ));
   m_BtnImgBkgrnd          .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_IMAGE_BACKGROUND  ));
   m_BtnColorBkgrnd        .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_COLOR_BACKGROUND  ));
   m_BtnImgBorder          .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_BORDER_COLOR_WIDTH));
   m_BtnImgColorText       .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_CHARACTER_COLOR   ));
   m_BtnImgTypeFont        .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__CHECKBUTTON_FONT_TYPE         ));
   m_BtnReset              .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__RESET_TO_DEFAULT              ));
   m_StcPlace              .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE_PLACEMENT               ));
   m_StcAlign              .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE_ALIGN                   ));
   m_BtnRadioPlaceAsIs     .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE__AS_IS                  ));
   m_BtnRadioPlaceUniformly.SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE__UNIFORMLY              ));
   m_BtnRadioPlaceStretch  .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE__STRETCH                ));
   m_BtnRadioPlaceTile     .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__PLACE__TILE                   ));
   m_EditValueDescr        .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__WIDTH_BORDER                  ));


   m_Skin = GetFM2WinMain().GetSkin();
   if (CImage(m_Skin.m_ImgsPause.GetImg(m_Skin.m_ImgsPause.GetSize()-1)).Valid()) {
      //      
      m_Skin.m_ImgsPause.AddImg(CImageSerialize());
   }

   { //  
      RECTEX rc = ::ScreenToClient(m_hWnd, ::GetWindowRect(m_BtnImgMine.m_hWnd));
      rc.height(rc.height()-1);
      m_BtnImgMine     .MoveWindow(&rc                     , FALSE);
      const int k=-1;
      m_BtnImgFlag     .MoveWindow(&rc.moveY(rc.height()-k), FALSE);
      m_BtnImgPause    .MoveWindow(&rc.moveY(rc.height()-k), FALSE);
      m_BtnImgBtnPause .MoveWindow(&rc.moveY(rc.height()-k), FALSE);
      m_BtnImgBtnNew   .MoveWindow(&rc.moveY(rc.height()-k), FALSE);
      m_BtnImgBkgrnd   .MoveWindow(&rc.moveY(rc.height()-k), FALSE);
      m_BtnColorBkgrnd .MoveWindow(&rc.moveY(rc.height()-k), FALSE);
      m_BtnImgBorder   .MoveWindow(&rc.moveY(rc.height()-k), FALSE);
      m_BtnImgColorText.MoveWindow(&rc.moveY(rc.height()-k), FALSE);
      m_BtnImgTypeFont .MoveWindow(&rc.moveY(rc.height()-k), FALSE);
   }

   m_skinPart = eSkinImageMine;
   m_BtnImgMine.SetCheck(BST_CHECKED);

   m_PreView.Create(GetDlgItem(IDC_CHANGESKIN_BUTTON_FRAME), RECTEX());

   ReInitDialog();

 //SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_BUTTON_BORDER             );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_BUTTON_TRANSPARENTorSETALL);
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_STATIC_PLACE              );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_STATIC_ALIGMENT           );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_LEFT            );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_CENTER          );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_TOP_RIGHT           );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_LEFT         );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_CENTER       );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT        );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_LEFT         );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_CENTER       );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT        );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_AS_IS               );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_UNIFORMLY           );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_STRETCH             );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_RADIO_TILE                );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_BUTTON_FRAME              );
   SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_SPIN_VALUE                );
 //SETNEWWNDPROC(m_hWnd, IDC_CHANGESKIN_SPIN_PREVIEW              ); //   !!!

   CDialogMessageHook::InstallHook(m_hWnd);

   return TRUE;
}

CImageSerialize CDialogChangeSkin::GetDefaultImage() {
   switch (m_skinPart) {
   case eSkinImageMine    : return CSkin().m_ImgMine;
   case eSkinImageFlag    : return CSkin().m_ImgFlag;
   case eSkinImagePause   : return CSkin().m_ImgsPause.GetImg(m_SpinPreView.GetPos());
   case eSkinImageBckgrnd : return CSkin().m_ImgBckgrnd;
   case eSkinImageBtnNew  : return CSkin().m_ImgBtnNew  [m_SpinPreView.GetPos()];
   case eSkinImageBtnPause: return CSkin().m_ImgBtnPause[m_SpinPreView.GetPos()];
   }
   return CImageSerialize();
}

CImageSerialize& CDialogChangeSkin::GetSkinImage() {
   switch (m_skinPart) {
   case eSkinImageMine    : return m_Skin.m_ImgMine;
   case eSkinImageFlag    : return m_Skin.m_ImgFlag;
   case eSkinImagePause   : return m_Skin.m_ImgsPause.GetImgRef(m_SpinPreView.m_hWnd ? m_SpinPreView.GetPos() : 0);
   case eSkinImageBckgrnd : return m_Skin.m_ImgBckgrnd;
   case eSkinImageBtnNew  : return m_Skin.m_ImgBtnNew  [m_SpinPreView.m_hWnd ? m_SpinPreView.GetPos() : 0];
   case eSkinImageBtnPause: return m_Skin.m_ImgBtnPause[m_SpinPreView.m_hWnd ? m_SpinPreView.GetPos() : 0];
   }
   static CImageSerialize imgGarbage;
   return imgGarbage;
}

COLORREF CDialogChangeSkin::GetSkinColor(bool bBtnSelect2) {
   COLORREF color = CLR_INVALID;
   switch(m_skinPart) {
   case eSkinBorder:
      if (bBtnSelect2)
           color = m_Skin.m_Border.m_colorShadow;
      else color = m_Skin.m_Border.m_colorLight;
      break;
   case eSkinColorBckgrnd:
      color = m_Skin.GetBkColor();
      break;
   case eSkinColorText:
      {
         int val = m_SpinPreView.GetPos();
         if (val) color = m_Skin.m_ColorText.m_colorOpen [val];
             else color = m_Skin.m_ColorText.m_colorClose[ 0 ];
      }
      break;
   }
   return color;
}

void CDialogChangeSkin::SetSkinColor(COLORREF color, bool bBtnSelect2) {
   switch(m_skinPart) {
   case eSkinBorder:
      if (bBtnSelect2)
           m_Skin.m_Border.m_colorShadow = color;
      else m_Skin.m_Border.m_colorLight  = color;
      break;
   case eSkinColorBckgrnd:
      m_Skin.SetBkColor(color);
      break;
   case eSkinColorText:
      {
         int val = m_SpinPreView.GetPos();
         if (val) m_Skin.m_ColorText.m_colorOpen [val] = color;
             else m_Skin.m_ColorText.m_colorClose[ 0 ] = color;
      }
      break;
   }
}

void CDialogChangeSkin::InvalidateFrame() {
   RECTEX redraw = ::GetWindowRect(m_StcFrame.m_hWnd);
   redraw = ::ScreenToClient(m_hWnd, redraw);
   InvalidateRect(&redraw, TRUE);
}

void CDialogChangeSkin::ReInitDialog() {
   if (m_SpinPreView.m_hWnd) {
      m_SpinPreView.DestroyWindow(); m_SpinPreView.Detach();
   }

   switch (m_skinPart) {
   case eSkinImagePause:
      {
         static int iOffX = 140;
         SetWindowPos(NULL, 0,0, m_sizeDlgDef.cx+iOffX, m_sizeDlgDef.cy, SWP_NOZORDER | SWP_NOMOVE);
         m_EditValueDescr.MoveWindow(&RECTEX(m_rcEditValDescr).moveX(iOffX).moveY(-55).height(95));
         m_EditValue     .MoveWindow(&RECTEX(m_rcEditVal     ).moveX(iOffX).moveY(-50));
         m_SpinValue     .MoveWindow(&RECTEX(m_rcSpinVal     ).moveX(iOffX).moveY(-50));
      }
      break;
   default:
      SetWindowPos(NULL, 0,0, m_sizeDlgDef.cx, m_sizeDlgDef.cy, SWP_NOZORDER | SWP_NOMOVE);
      m_EditValueDescr.MoveWindow(&m_rcEditValDescr);
      m_EditValue     .MoveWindow(&m_rcEditVal     );
      m_SpinValue     .MoveWindow(&m_rcSpinVal     );
   }

   m_BtnCheckTransparentOrSetAll.SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_TRANSPARENT));
   switch (m_skinPart) {
   case eSkinImageMine    :
   case eSkinImageFlag    :
   case eSkinImageBtnNew  :
   case eSkinImageBtnPause:
   case eSkinImageBckgrnd : m_BtnSelect                  .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_IMAGE       )); break;
   case eSkinImagePause   : m_BtnSelect                  .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_IMAGE       ));
                            m_EditValueDescr             .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__TIMER_PAUSE        )); break;
   case eSkinTypeFont     : m_BtnSelect                  .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_FONT        )); break;
   case eSkinColorBckgrnd : m_BtnCheckTransparentOrSetAll.SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_APPLY_TO_ALL));
   case eSkinColorText    : m_BtnSelect                  .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_COLOR       )); break;
   case eSkinBorder       : m_BtnSelect                  .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_LIGHT_COLOR ));
                            m_BtnSelect2                 .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__BUTTON_SHADOW_COLOR));
                            m_EditValueDescr             .SetWindowText(CLang::GetString(IDS__DIALOG_CHANGESKIN__WIDTH_BORDER       )); break;
   }

   switch (m_skinPart) {
   case eSkinImageMine:
   case eSkinImageFlag:
   case eSkinImagePause:
   case eSkinImageBtnPause:
   case eSkinImageBtnNew:
   case eSkinImageBckgrnd:
      m_BtnCheckTransparentOrSetAll.ShowWindow(SW_SHOW);
      m_StcPlace                   .ShowWindow(SW_SHOW);
      m_StcAlign                   .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceTopLeft       .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceTopCenter     .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceTopRight      .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceMiddleLeft    .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceMiddleCenter  .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceMiddleRight   .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceBottomLeft    .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceBottomCenter  .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceBottomRight   .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceAsIs          .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceUniformly     .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceStretch       .ShowWindow(SW_SHOW);
      m_BtnRadioPlaceTile          .ShowWindow(SW_SHOW);

      m_BtnSelect2                 .ShowWindow(SW_HIDE);
      m_EditValueDescr             .ShowWindow((m_skinPart == eSkinImagePause) ? SW_SHOW : SW_HIDE);
      m_EditValue                  .ShowWindow((m_skinPart == eSkinImagePause) ? SW_SHOW : SW_HIDE);
      m_SpinValue                  .ShowWindow((m_skinPart == eSkinImagePause) ? SW_SHOW : SW_HIDE);
      break;
   case eSkinColorBckgrnd:
   case eSkinBorder:
   case eSkinColorText:
   case eSkinTypeFont:
      m_StcPlace                   .ShowWindow(SW_HIDE);
      m_StcAlign                   .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceTopLeft       .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceTopCenter     .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceTopRight      .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceMiddleLeft    .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceMiddleCenter  .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceMiddleRight   .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceBottomLeft    .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceBottomCenter  .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceBottomRight   .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceAsIs          .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceUniformly     .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceStretch       .ShowWindow(SW_HIDE);
      m_BtnRadioPlaceTile          .ShowWindow(SW_HIDE);

      switch (m_skinPart) {
      case eSkinColorBckgrnd:
         m_BtnCheckTransparentOrSetAll.ShowWindow(SW_SHOW);
         m_BtnSelect2                 .ShowWindow(SW_HIDE);
         m_EditValueDescr             .ShowWindow(SW_HIDE);
         m_EditValue                  .ShowWindow(SW_HIDE);
         m_SpinValue                  .ShowWindow(SW_HIDE);
         break;
      case eSkinBorder:
         m_BtnCheckTransparentOrSetAll.ShowWindow(SW_HIDE);
         m_BtnSelect2                 .ShowWindow(SW_SHOW);
         m_EditValueDescr             .ShowWindow(SW_SHOW);
         m_EditValue                  .ShowWindow(SW_SHOW);
         m_SpinValue                  .ShowWindow(SW_SHOW);
         break;
      case eSkinColorText:
      case eSkinTypeFont:
         m_BtnCheckTransparentOrSetAll.ShowWindow(SW_HIDE);
         m_BtnSelect2                 .ShowWindow(SW_HIDE);
         m_EditValueDescr             .ShowWindow(SW_HIDE);
         m_EditValue                  .ShowWindow(SW_HIDE);
         m_SpinValue                  .ShowWindow(SW_HIDE);
         break;
      }
      break;
   }

   m_BtnRadioPlaceAsIs          .EnableWindow(TRUE);
   m_BtnRadioPlaceUniformly     .EnableWindow(TRUE);
   m_BtnRadioPlaceStretch       .EnableWindow(TRUE);
   m_BtnRadioPlaceTile          .EnableWindow(TRUE);
   m_BtnCheckTransparentOrSetAll.EnableWindow(TRUE);

   RECTEX rc(::GetWindowRect(m_StcFrame.m_hWnd));
   SIZE sizeOut = rc.size();
   SIZE sizeIn = {10,10};
   switch (m_skinPart) {
   case eSkinImagePause  :
   case eSkinImageBckgrnd:
   case eSkinColorBckgrnd: sizeIn = GetFM2WinMain().GetSizeMosaicWindow();
   }
   rc = FindInnerRect(sizeIn, sizeOut);
   ::MoveWindow(m_PreView.m_hWnd, rc);

   int nUpper, nLower, nPos;
   switch (m_skinPart) {
   case eSkinBorder:
      m_SpinValue.SetRange(1, 10);
      m_SpinValue.SetPos(m_Skin.m_Border.m_iWidth);
      break;
   case eSkinImageBtnPause:
   case eSkinImageBtnNew  : nPos = 0        ; nLower = 0              ; nUpper = 3         ; break;
   case eSkinColorText    : nPos = CCell::_1; nLower = CCell::_Unknown; nUpper = CCell::_21; break;
   case eSkinImagePause   : nPos = 0        ; nLower = 0              ; nUpper = m_Skin.m_ImgsPause.GetSize()-1;
      m_SpinValue.SetRange(1, MAX_TIMER_PAUSE);
      m_SpinValue.SetPos(m_Skin.m_iTimerPause);
      break;
   case eSkinColorBckgrnd :
      m_BtnCheckTransparentOrSetAll.SetCheck(m_Skin.m_bToAll ? BST_CHECKED : BST_UNCHECKED);
      break;
   }

   switch (m_skinPart) {
   case eSkinImageBtnPause:
   case eSkinImageBtnNew:
   case eSkinColorText:
   case eSkinImagePause: 
      m_SpinPreView.Attach(::CreateUpDownControl(
         WS_CHILD | WS_VISIBLE | UDS_ALIGNRIGHT | UDS_SETBUDDYINT,
         0,0,20,30,
         m_StcFrame.m_hWnd,
         IDC_CHANGESKIN_SPIN_PREVIEW,
         ::GetModuleHandle(NULL),
         m_PreView.m_hWnd,
         nUpper, nLower, nPos));
      defWndProc_IDC_CHANGESKIN_SPIN_PREVIEW() = ::SetWindowProc(m_SpinPreView.m_hWnd, newWndProc_IDC_CHANGESKIN_SPIN_PREVIEW);
   }

   AcceptImage();

   InvalidateFrame();
}

void CDialogChangeSkin::OnClickSkinPart(UINT /*wNotifyCode*/, int idControl, HWND /*hWndCtl*/) {
   m_skinPart = ESkinPart(idControl-IDC_CHANGESKIN_BUTTON_IMAGE_MINE);
   ReInitDialog();
}

#define CDialogChangeSkin__OnSpinChange(iVal, spin, iMax) { \
   int iRes = spin.GetPos(); \
   iVal = min(LOWORD(iRes), iMax); \
   spin.SetPos(iVal); \
}

void CDialogChangeSkin::OnSpinValue(UINT /*wNotifyCode*/, int /*idControl*/, HWND /*hWndCtl*/) {
   if (m_SpinValue.m_hWnd) {
      switch (m_skinPart) {
      case eSkinImagePause: CDialogChangeSkin__OnSpinChange(m_Skin.m_iTimerPause    , m_SpinValue, MAX_TIMER_PAUSE); break;
      case eSkinBorder    : CDialogChangeSkin__OnSpinChange(m_Skin.m_Border.m_iWidth, m_SpinValue, 10             ); break;
      }
      m_PreView.InvalidateRect(NULL, TRUE);
   }
}

void CDialogChangeSkin::OnClickSelect(UINT /*wNotifyCode*/, int idControl, HWND /*hWndCtl*/) {
   switch (m_skinPart) {
   case eSkinImageMine    :
   case eSkinImageFlag    :
   case eSkinImagePause   :
   case eSkinImageBtnNew  :
   case eSkinImageBtnPause:
   case eSkinImageBckgrnd : {
         CDialogTemplateSelectImage dlgTmplSI(
            m_hWnd,
            NULL,
            GetSkinImage().m_strPath.IsEmpty() ? ::GetCurrentDirectory() : GetSkinImage().m_strPath, 
            CLang::GetString(IDS__DIALOG_CHANGESKIN__OPENFILENAME_TITLE_OPEN_IMAGE),
            NULL);
         if (IDOK == dlgTmplSI.DoModal()) {
            GetSkinImage().m_strPath = dlgTmplSI.m_strFile+dlgTmplSI.m_strResTypeAndName;
            AcceptImage();
            if (CImage(GetSkinImage()).Valid() && (m_skinPart==eSkinImagePause)) {
               //         ,     
               //    (    ).
               if ((m_Skin.m_ImgsPause.GetSize()-1) == m_SpinPreView.GetPos()) {
                  m_Skin.m_ImgsPause.AddImg(CImageSerialize());
                  m_SpinPreView.SetRange(0, m_Skin.m_ImgsPause.GetSize()-1); 
               }
            }
         }
      }
      break;
   case eSkinBorder      :
   case eSkinColorBckgrnd:
   case eSkinColorText   :
      {
         static COLORREF colors[16] = {
            0x000000, 0x0000FF, 0x00FF00, 0x00FFFF, 0xFF0000, 0xFF00FF, 0xFFFF00, 0xFFFFFF,
            0xFFF000, 0x00007F, 0x007F00, 0x007F7F, 0x7F0000, 0x7F007F, 0x7F7F00, 0x7F7F7F
         };
         CHOOSECOLOR sChooseColor;
         sChooseColor.lStructSize  = sizeof(CHOOSECOLOR);
         sChooseColor.hwndOwner    = m_hWnd;
         sChooseColor.hInstance    = (HWND)::GetModuleHandle(NULL);
         sChooseColor.rgbResult    = GetSkinColor(idControl == IDC_CHANGESKIN_BUTTON_SELECT2);
         sChooseColor.lpCustColors = colors;
         sChooseColor.Flags        = CC_RGBINIT | CC_FULLOPEN | CC_SOLIDCOLOR;
       //sChooseColor.lCustData;
       //sChooseColor.lpfnHook;
       //sChooseColor.lpTemplateName;
         if (::ChooseColor(&sChooseColor)) {
            SetSkinColor(sChooseColor.rgbResult, (idControl == IDC_CHANGESKIN_BUTTON_SELECT2));
         }
      }
      break;
   case eSkinTypeFont:
      {
         CHOOSEFONT sChooseFont;
         LOGFONT LogFont = m_Skin.m_Font;
         sChooseFont.lStructSize = sizeof(CHOOSEFONT);
         sChooseFont.hwndOwner   = m_hWnd;
         sChooseFont.hDC         = NULL;
         sChooseFont.lpLogFont   = &LogFont;
         sChooseFont.iPointSize  = 0;
         sChooseFont.Flags       = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;// CF_BOTH | CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT | CF_NOSCRIPTSEL | CF_NOSTYLESEL | CF_NOSIZESEL | CF_NOVERTFONTS | CF_SCREENFONTS | CF_SELECTSCRIPT;// | CF_LIMITSIZE;
       //sChooseFont.rgbColors   = 0;
       //sChooseFont.lCustData
       //sChooseFont.lpfnHook
       //sChooseFont.lpTemplateName
         sChooseFont.hInstance   = ::GetModuleHandle(NULL);
       //sChooseFont.lpszStyle
         sChooseFont.nFontType   = SCREEN_FONTTYPE;
       //sChooseFont.___MISSING_ALIGNMENT__
       //sChooseFont.nSizeMin
       //sChooseFont.nSizeMax
         if (::ChooseFont(&sChooseFont)) 
            m_Skin.m_Font = LogFont;
      }
      break;
   }
   m_PreView.InvalidateRect(NULL, TRUE);
}

void CDialogChangeSkin::OnClickTransparentOrSetAll(UINT /*wNotifyCode*/, int /*idControl*/, HWND /*hWndCtl*/) {
   BOOL bCheck = (BST_CHECKED == m_BtnCheckTransparentOrSetAll.GetCheck());
   if (m_skinPart == eSkinColorBckgrnd) {
      m_Skin.m_bToAll = bCheck;
   } else {
      GetSkinImage().m_bTransparent = bCheck;
   }
   if (m_skinPart == eSkinColorBckgrnd) {
      InvalidateRect(NULL, TRUE);
   } else {
      m_PreView.InvalidateRect(NULL, TRUE);
   }
}

void CDialogChangeSkin::OnClickPlace(UINT /*wNotifyCode*/, int idControl, HWND /*hWndCtl*/) {
   switch (idControl) {
   case IDC_CHANGESKIN_RADIO_TOP_LEFT     : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceTop    | CImg::ePlaceLeft  ; break;
   case IDC_CHANGESKIN_RADIO_TOP_CENTER   : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceTop    | CImg::ePlaceCenter; break;
   case IDC_CHANGESKIN_RADIO_TOP_RIGHT    : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceTop    | CImg::ePlaceRight ; break;
   case IDC_CHANGESKIN_RADIO_MIDDLE_LEFT  : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceMiddle | CImg::ePlaceLeft  ; break;
   case IDC_CHANGESKIN_RADIO_MIDDLE_CENTER: GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceMiddle | CImg::ePlaceCenter; break;
   case IDC_CHANGESKIN_RADIO_MIDDLE_RIGHT : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceMiddle | CImg::ePlaceRight ; break;
   case IDC_CHANGESKIN_RADIO_BOTTOM_LEFT  : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceBottom | CImg::ePlaceLeft  ; break;
   case IDC_CHANGESKIN_RADIO_BOTTOM_CENTER: GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceBottom | CImg::ePlaceCenter; break;
   case IDC_CHANGESKIN_RADIO_BOTTOM_RIGHT : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x30) | CImg::ePlaceBottom | CImg::ePlaceRight ; break;
   case IDC_CHANGESKIN_RADIO_AS_IS        : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x0F) | CImg::ePlaceAsIs     ; break;
   case IDC_CHANGESKIN_RADIO_UNIFORMLY    : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x0F) | CImg::ePlaceUniformly; break;
   case IDC_CHANGESKIN_RADIO_STRETCH      : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x0F) | CImg::ePlaceStretch  ; break;
   case IDC_CHANGESKIN_RADIO_TILE         : GetSkinImage().m_Place = (GetSkinImage().m_Place & 0x0F) | CImg::ePlaceTile     ; break;
   }
   AcceptImage();
   m_PreView.InvalidateRect(NULL, TRUE);
}

void CDialogChangeSkin::OnClickReset(UINT /*wNotifyCode*/, int /*idControl*/, HWND /*hWndCtl*/) {
   GetSkinImage() = GetDefaultImage();
   switch (m_skinPart) {
   case eSkinColorBckgrnd : m_Skin.SetBkColor  ( CSkin().GetBkColor());
                            m_Skin.m_bToAll    = CSkin().m_bToAll     ; break;
   case eSkinBorder       : m_Skin.m_Border    = CSkin().m_Border     ; break;
   case eSkinColorText    : m_Skin.m_ColorText = CSkin().m_ColorText  ; break;
   case eSkinTypeFont     : m_Skin.m_Font      = CSkin().m_Font       ; break;
   }

   AcceptImage();

   switch (m_skinPart) {
   case eSkinBorder       : m_SpinValue.SetPos(m_Skin.m_Border.m_iWidth); break;
   case eSkinColorBckgrnd : m_BtnCheckTransparentOrSetAll.SetCheck(m_Skin.m_bToAll ? BST_CHECKED : BST_UNCHECKED);
                            InvalidateRect(NULL, TRUE);
                            break;
   }
   ::InvalidateRect(m_PreView.m_hWnd, NULL, TRUE);
}

void CDialogChangeSkin::OnClickOkCancel(UINT /*wNotifyCode*/, int idControl, HWND /*hWndCtl*/) {
   if (idControl == IDOK) {
      GetFM2WinMain().SetSkin(m_Skin);
   }
   SendMessage(WM_CLOSE, 0L, 0L);
}

void CDialogChangeSkin::OnClose(){
   DestroyWindow();
}

void CDialogChangeSkin::OnDestroy() {
   CDialogMessageHook::UninstallHook(m_hWnd);
   if (m_SpinPreView.m_hWnd) {
      m_SpinPreView.DestroyWindow(); m_SpinPreView.Detach();
   }
}

BOOL CDialogChangeSkin::OnEraseBkgnd(HDC hDC) {
 //if (!GetFM2WinMain().GetSkin().m_bToAll)
   if (!m_Skin.m_bToAll) {
      SetMsgHandled(FALSE);
      return FALSE;
   }
 //return nsEraseBk::OnEraseBkgnd(m_hWnd, hDC, GetFM2WinMain().GetSkin().GetBkColor());
   return nsEraseBk::OnEraseBkgnd(m_hWnd, hDC, m_Skin.GetBkColor());
}

void CDialogChangeSkin::AcceptImage() {
   switch (m_skinPart) {
   case eSkinImageMine    :
   case eSkinImageFlag    :
   case eSkinImageBtnNew  :
   case eSkinImageBtnPause:
   case eSkinImagePause   :
   case eSkinImageBckgrnd :
      {
         CImg::EImageType eType = CImage(GetSkinImage()).GetImageType();
         BOOL bImg = (eType != CImg::eImageUnk);
         BOOL bAlign = bImg && (((GetSkinImage().m_Place&0x30)==CImg::ePlaceAsIs) || ((GetSkinImage().m_Place&0x30)==CImg::ePlaceUniformly));

         m_StcPlace                   .EnableWindow(bImg);
         m_StcAlign                   .EnableWindow(bAlign);
         m_BtnCheckTransparentOrSetAll.EnableWindow(bImg && (eType == CImg::eImageBMP));

         m_BtnRadioPlaceTopLeft       .EnableWindow(bAlign);
         m_BtnRadioPlaceTopCenter     .EnableWindow(bAlign);
         m_BtnRadioPlaceTopRight      .EnableWindow(bAlign);
         m_BtnRadioPlaceMiddleLeft    .EnableWindow(bAlign);
         m_BtnRadioPlaceMiddleCenter  .EnableWindow(bAlign);
         m_BtnRadioPlaceMiddleRight   .EnableWindow(bAlign);
         m_BtnRadioPlaceBottomLeft    .EnableWindow(bAlign);
         m_BtnRadioPlaceBottomCenter  .EnableWindow(bAlign);
         m_BtnRadioPlaceBottomRight   .EnableWindow(bAlign);

         m_BtnRadioPlaceAsIs          .EnableWindow(bImg);
         m_BtnRadioPlaceUniformly     .EnableWindow(bImg);
         m_BtnRadioPlaceStretch       .EnableWindow(bImg);
         m_BtnRadioPlaceTile          .EnableWindow(bImg);

         if (bImg) {
            #define SetCheck(CWinControl, bCheck) CWinControl.SetCheck(bCheck ? BST_CHECKED : BST_UNCHECKED);

            SetCheck(m_BtnCheckTransparentOrSetAll, GetSkinImage().m_bTransparent);

            SetCheck(m_BtnRadioPlaceTopLeft       , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceTop    | CImg::ePlaceLeft  ));
            SetCheck(m_BtnRadioPlaceTopCenter     , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceTop    | CImg::ePlaceCenter));
            SetCheck(m_BtnRadioPlaceTopRight      , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceTop    | CImg::ePlaceRight ));
            SetCheck(m_BtnRadioPlaceMiddleLeft    , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceMiddle | CImg::ePlaceLeft  ));
            SetCheck(m_BtnRadioPlaceMiddleCenter  , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceMiddle | CImg::ePlaceCenter));
            SetCheck(m_BtnRadioPlaceMiddleRight   , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceMiddle | CImg::ePlaceRight ));
            SetCheck(m_BtnRadioPlaceBottomLeft    , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceBottom | CImg::ePlaceLeft  ));
            SetCheck(m_BtnRadioPlaceBottomCenter  , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceBottom | CImg::ePlaceCenter));
            SetCheck(m_BtnRadioPlaceBottomRight   , (GetSkinImage().m_Place & 0x0F)==(CImg::ePlaceBottom | CImg::ePlaceRight ));

            SetCheck(m_BtnRadioPlaceAsIs          , (GetSkinImage().m_Place & 0x30)==CImg::ePlaceAsIs);
            SetCheck(m_BtnRadioPlaceUniformly     , (GetSkinImage().m_Place & 0x30)==CImg::ePlaceUniformly);
            SetCheck(m_BtnRadioPlaceStretch       , (GetSkinImage().m_Place & 0x30)==CImg::ePlaceStretch);
            SetCheck(m_BtnRadioPlaceTile          , (GetSkinImage().m_Place & 0x30)==CImg::ePlaceTile);
            #undef SetCheck
         }
      }
   }
}

////////////////////////////////////////////////////////////////////////////////
//                          implementation CWinSkinPreView
////////////////////////////////////////////////////////////////////////////////
CDialogChangeSkin::CWinSkinPreView::CWinSkinPreView(CDialogChangeSkin &SkinDialog) :
   m_SkinDialog(SkinDialog)
{}

BOOL CDialogChangeSkin::CWinSkinPreView::OnSetText(LPCTSTR szText) {
   //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogChangeSkin::CWinSkinPreView::OnSetText: szText=[%s]"), szText);
   FORWARD_WM_SETTEXT(m_hWnd, szText, ::DefWindowProc);
   InvalidateRect(NULL, TRUE);
   m_SkinDialog.AcceptImage();
   return FALSE;
}

BOOL CDialogChangeSkin::CWinSkinPreView::OnEraseBkgnd(HDC hDC) {
   return FALSE;
}

void CDialogChangeSkin::CWinSkinPreView::OnPaint(HDC) {
   CPaintDC hDC(m_hWnd);

   RECT Rect; GetClientRect(&Rect);

   HBITMAP hBmp = ::CreateCompatibleBitmap(hDC, Rect.right,Rect.bottom);

   CDC hCDC; hCDC.CreateCompatibleDC(hDC);
   HBITMAP hOldBmp = hCDC.SelectBitmap(hBmp);
   {
      CBrush hBrushNew;
      switch (m_SkinDialog.m_skinPart) {
      case eSkinImageBtnNew  :
      case eSkinImageBtnPause:
         if (!m_SkinDialog.m_Skin.m_bToAll) {
            hBrushNew.CreateSolidBrush(::GetSysColor(COLOR_BTNFACE));
            break;
         }
      default:
         hBrushNew.CreateSolidBrush(m_SkinDialog.m_Skin.GetBkColor());
      }
      HBRUSH hBrushOld = hCDC.SelectBrush(hBrushNew);
      hCDC.PatBlt(0,0, Rect.right,Rect.bottom, PATCOPY);
      hCDC.SelectBrush(hBrushOld);
   }
   switch (m_SkinDialog.m_skinPart) {
   case eSkinImageBtnNew  :
   case eSkinImageBtnPause:
   case eSkinImageMine    :
   case eSkinImageFlag    :
   case eSkinImagePause   :
   case eSkinImageBckgrnd :
      CImage(m_SkinDialog.GetSkinImage()).Draw(hCDC, Rect);
      break;
   case eSkinBorder     :
      {
         float a = toFLOAT(Rect.right)*4/10;
         float h = a*(float)sqrt(3.)/2;
         float c = toFLOAT(Rect.right)/2; // center
         POINT p[6] = {{toINT(c  ),toINT(c-a  )},
                       {toINT(c+h),toINT(c-a/2)},
                       {toINT(c+h),toINT(c+a/2)},
                       {toINT(c  ),toINT(c+a  )},
                       {toINT(c-h),toINT(c+a/2)},
                       {toINT(c-h),toINT(c-a/2)}};
         CPen hPenNew; hPenNew.CreatePen(PS_SOLID, m_SkinDialog.m_Skin.m_Border.m_iWidth, m_SkinDialog.m_Skin.m_Border.m_colorShadow);
         HPEN hPenOld = hCDC.SelectPen(hPenNew);
         hCDC.MoveTo(p[0]);
         hCDC.LineTo(p[1]);
         hCDC.LineTo(p[2]);
         hCDC.LineTo(p[3]);
         hCDC.SelectPen(hPenOld);
         hPenNew.DeleteObject();
         hPenNew.CreatePen(PS_SOLID, m_SkinDialog.m_Skin.m_Border.m_iWidth, m_SkinDialog.m_Skin.m_Border.m_colorLight);
         hPenOld = hCDC.SelectPen(hPenNew);
         hCDC.LineTo(p[4]);
         hCDC.LineTo(p[5]);
         hCDC.LineTo(p[0]);
         hCDC.SelectPen(hPenOld);

      }
      break;
   case eSkinColorText:
      {
         COLORREF clr = m_SkinDialog.GetSkinColor(false);
         hCDC.SetTextColor(clr);
         hCDC.SetBkMode   (TRANSPARENT);
         GetClientRect(&Rect);
         m_SkinDialog.m_Skin.m_Font.lfHeight = Rect.bottom;
         CFont hFontNew = ::CreateFontIndirect(&m_SkinDialog.m_Skin.m_Font);
         HFONT hFontOld = hCDC.SelectFont(hFontNew);
         TCHAR const *szCaption;
         int iVal = m_SkinDialog.m_SpinPreView.GetPos();
         if (iVal) {
            szCaption = CCell::GetCaptionOpen((CCell::EOpen)iVal);
         } else {
            szCaption = CCell::GetCaptionClose(CCell::_Unknown);
         }
         hCDC.DrawText(szCaption, -1, &Rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
         hCDC.SelectFont(hFontOld);

      }
      break;
   case eSkinTypeFont:
      {
         TCHAR str [] = _T("\n\nFastMines - best\nMinesweeper clone!\n\n0 1 2 3 4 5 6 7 8 9 ?");
         TCHAR str1[] = _T("FastMines - best");
         TCHAR str2[] = _T("Minesweeper clone!");
         TCHAR str3[] = _T("0 1 2 3 4 5 6 7 8 9 ?");
         SIZE size1, size2, size3;

         ::SetBkMode   (hCDC, TRANSPARENT);
         ::SetTextColor(hCDC, RGB(0, 0, 0));

         ::GetClientRect(m_hWnd, &Rect);
         CFont hFontNew = NULL;
         HFONT hFontOld = NULL;         
         m_SkinDialog.m_Skin.m_Font.lfHeight = 0;
         do {
            m_SkinDialog.m_Skin.m_Font.lfHeight++;
            hFontNew.CreateFontIndirect(&m_SkinDialog.m_Skin.m_Font);
            hFontOld = hCDC.SelectFont(hFontNew);

            hCDC.GetTextExtent(str1, lstrlen(str1), &size1);
            hCDC.GetTextExtent(str2, lstrlen(str2), &size2);
            hCDC.GetTextExtent(str3, lstrlen(str3), &size3);

            hCDC.SelectFont(hFontOld);
            hFontNew.DeleteObject();
         } while (max(max(size1.cx, size2.cx), size3.cx) < (Rect.right-Rect.left));
         m_SkinDialog.m_Skin.m_Font.lfHeight--;
         hFontNew.CreateFontIndirect(&m_SkinDialog.m_Skin.m_Font);
         hFontOld = hCDC.SelectFont(hFontNew);
         hCDC.DrawText(str, -1, &Rect, DT_CENTER); // hCDC.ExtTextOut(0,0, ETO_CLIPPED, &Rect, str1, strlen(str1), NULL);
         hCDC.SelectFont(hFontOld);

      }
      break;
   }
   ::BitBlt(hDC, Rect, hCDC, SRCCOPY);
   hCDC.SelectBitmap(hOldBmp);

   ::DeleteObject(hBmp);
}

#endif // _WTL_VER

////////////////////////////////////////////////////////////////////////////////
//                           implementation CFileSkin
////////////////////////////////////////////////////////////////////////////////

BOOL CFileSkin::Convert(HANDLE hFile) {
   //     2.2007.02.12
   BOOL bRes = (::SetFilePointer(hFile, 0, NULL, FILE_BEGIN) != 0xFFFFFFFF);
   if (!bRes) return FALSE;
   nsVer20070212::CFileSkin skinOld;
   skinOld.SetFileHandle(hFile);
   bRes = skinOld.LoadFile();
   if (bRes) {
      nsVer20070212::CSkin skin20070212 = skinOld.GetSkin();

      m_Body.m_Border.m_colorLight  = skin20070212.m_Border.m_colorLight;
      m_Body.m_Border.m_colorShadow = skin20070212.m_Border.m_colorShadow;
      m_Body.m_Border.m_iWidth      = skin20070212.m_Border.m_iWidth;

      m_Body.m_bToAll = skin20070212.m_bToAll;

      m_Body.SetBkColor(skin20070212.GetBkColor());

      m_Body.m_ColorText.m_colorOpen[CCell::_Nil ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_Nil ];
      m_Body.m_ColorText.m_colorOpen[CCell::_1   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_1   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_2   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_2   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_3   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_3   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_4   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_4   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_5   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_5   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_6   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_6   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_7   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_7   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_8   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_8   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_9   ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_9   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_10  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_10  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_11  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_11  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_12  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_12  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_13  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_13  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_14  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_14  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_15  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_15  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_16  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_16  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_17  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_17  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_18  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_18  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_19  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_19  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_20  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_20  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_21  ] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_21  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_Mine] = skin20070212.m_ColorText.m_colorOpen[nsVer20070212::_Mine];

      m_Body.m_ColorText.m_colorClose[CCell::_Unknown] = skin20070212.m_ColorText.m_colorClose[nsVer20070212::_Unknown];
      m_Body.m_ColorText.m_colorClose[CCell::_Clear  ] = skin20070212.m_ColorText.m_colorClose[nsVer20070212::_Clear  ];
      m_Body.m_ColorText.m_colorClose[CCell::_Flag   ] = skin20070212.m_ColorText.m_colorClose[nsVer20070212::_Flag   ];

      m_Body.m_Font = skin20070212.m_Font;

   #define CONVERT_IMG(thisImg, oldImg) \
      thisImg.m_bTransparent   = oldImg.m_bTransparent; \
      thisImg.m_clrTransparent = oldImg.m_clrTransparent; \
      thisImg.m_Place          = oldImg.m_Place; \
      thisImg.m_strPath        = oldImg.m_strPath;
      CONVERT_IMG(m_Body.m_ImgBckgrnd     , skin20070212.m_ImgBckgrnd);
      CONVERT_IMG(m_Body.m_ImgBtnNew[0]   , skin20070212.m_ImgBtnNew[0]);
      CONVERT_IMG(m_Body.m_ImgBtnNew[1]   , skin20070212.m_ImgBtnNew[1]);
      CONVERT_IMG(m_Body.m_ImgBtnNew[2]   , skin20070212.m_ImgBtnNew[2]);
      CONVERT_IMG(m_Body.m_ImgBtnNew[3]   , skin20070212.m_ImgBtnNew[3]);
      CONVERT_IMG(m_Body.m_ImgBtnPause[0] , skin20070212.m_ImgBtnPause[0]);
      CONVERT_IMG(m_Body.m_ImgBtnPause[1] , skin20070212.m_ImgBtnPause[1]);
      CONVERT_IMG(m_Body.m_ImgBtnPause[2] , skin20070212.m_ImgBtnPause[2]);
      CONVERT_IMG(m_Body.m_ImgBtnPause[3] , skin20070212.m_ImgBtnPause[3]);
      CONVERT_IMG(m_Body.m_ImgFlag        , skin20070212.m_ImgFlag);
      CONVERT_IMG(m_Body.m_ImgMine        , skin20070212.m_ImgMine);
      CImageSerialize imgTmpPause;
      CONVERT_IMG(imgTmpPause             , skin20070212.m_ImgPause);
      m_Body.m_ImgsPause.Clear();
      m_Body.m_ImgsPause.AddImg(imgTmpPause);
   #undef CONVERT_IMG

      m_Body.m_iTimerPause = CSkin().m_iTimerPause;

      return TRUE;
   }

   //     2.10
   bRes = (::SetFilePointer(hFile, 0, NULL, FILE_BEGIN) != 0xFFFFFFFF);
   if (!bRes) return FALSE;

   this->m_Body = CSkin();
   nsVer210::CFileSkin FileSkin_v210;
   DWORD dwNOBR = 0;
   bRes = ::ReadFile(hFile, &FileSkin_v210, sizeof(FileSkin_v210), &dwNOBR, NULL) &&
         (sizeof(FileSkin_v210) == dwNOBR) &&
         (memcmp(FileSkin_v210.m_szVersion, ID_VERSIONINFO_VERSION3_v210, sizeof(ID_VERSIONINFO_VERSION3_v210)) == 0);

   if (bRes)  {
   #define CONVERT_PLACE(newPlace, oldPlace) \
      switch (oldPlace) { \
      case nsVer210::ePlaceCenter : newPlace = CImg::ePlaceUniformly | CImg::ePlaceCenter | CImg::ePlaceMiddle; break; \
      case nsVer210::ePlaceStretch: newPlace = CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle; break; \
      case nsVer210::ePlaceTile   : newPlace = CImg::ePlaceTile      | CImg::ePlaceCenter | CImg::ePlaceMiddle; break; \
      }
      m_Body.m_ImgMine       .m_strPath = FileSkin_v210.m_Skin.m_Mine       .m_szPath; m_Body.m_ImgMine       .m_bTransparent = FileSkin_v210.m_Skin.m_Mine       .m_bTransparent; CONVERT_PLACE(m_Body.m_ImgMine       .m_Place, FileSkin_v210.m_Skin.m_Mine       .m_Place);
      m_Body.m_ImgFlag       .m_strPath = FileSkin_v210.m_Skin.m_Flag       .m_szPath; m_Body.m_ImgFlag       .m_bTransparent = FileSkin_v210.m_Skin.m_Flag       .m_bTransparent; CONVERT_PLACE(m_Body.m_ImgFlag       .m_Place, FileSkin_v210.m_Skin.m_Flag       .m_Place);
      CImageSerialize img;img.m_strPath = FileSkin_v210.m_Skin.m_Pause      .m_szPath;                     img.m_bTransparent = FileSkin_v210.m_Skin.m_Pause      .m_bTransparent; CONVERT_PLACE(                    img.m_Place, FileSkin_v210.m_Skin.m_Pause      .m_Place);
      m_Body.m_ImgsPause.AddImg(img);
      m_Body.m_ImgBckgrnd    .m_strPath = FileSkin_v210.m_Skin.m_Bckgrnd    .m_szPath; m_Body.m_ImgBckgrnd    .m_bTransparent = FileSkin_v210.m_Skin.m_Bckgrnd    .m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBckgrnd    .m_Place, FileSkin_v210.m_Skin.m_Bckgrnd    .m_Place);
      m_Body.m_ImgBtnNew  [0].m_strPath = FileSkin_v210.m_Skin.m_BtnNew  [0].m_szPath; m_Body.m_ImgBtnNew  [0].m_bTransparent = FileSkin_v210.m_Skin.m_BtnNew  [0].m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBtnNew  [0].m_Place, FileSkin_v210.m_Skin.m_BtnNew  [0].m_Place);
      m_Body.m_ImgBtnNew  [1].m_strPath = FileSkin_v210.m_Skin.m_BtnNew  [1].m_szPath; m_Body.m_ImgBtnNew  [1].m_bTransparent = FileSkin_v210.m_Skin.m_BtnNew  [1].m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBtnNew  [1].m_Place, FileSkin_v210.m_Skin.m_BtnNew  [1].m_Place);
      m_Body.m_ImgBtnNew  [2].m_strPath = FileSkin_v210.m_Skin.m_BtnNew  [2].m_szPath; m_Body.m_ImgBtnNew  [2].m_bTransparent = FileSkin_v210.m_Skin.m_BtnNew  [2].m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBtnNew  [2].m_Place, FileSkin_v210.m_Skin.m_BtnNew  [2].m_Place);
      m_Body.m_ImgBtnNew  [3].m_strPath = FileSkin_v210.m_Skin.m_BtnNew  [3].m_szPath; m_Body.m_ImgBtnNew  [3].m_bTransparent = FileSkin_v210.m_Skin.m_BtnNew  [3].m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBtnNew  [3].m_Place, FileSkin_v210.m_Skin.m_BtnNew  [3].m_Place);
      m_Body.m_ImgBtnPause[0].m_strPath = FileSkin_v210.m_Skin.m_BtnPause[0].m_szPath; m_Body.m_ImgBtnPause[0].m_bTransparent = FileSkin_v210.m_Skin.m_BtnPause[0].m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBtnPause[0].m_Place, FileSkin_v210.m_Skin.m_BtnPause[0].m_Place);
      m_Body.m_ImgBtnPause[1].m_strPath = FileSkin_v210.m_Skin.m_BtnPause[1].m_szPath; m_Body.m_ImgBtnPause[1].m_bTransparent = FileSkin_v210.m_Skin.m_BtnPause[1].m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBtnPause[1].m_Place, FileSkin_v210.m_Skin.m_BtnPause[1].m_Place);
      m_Body.m_ImgBtnPause[2].m_strPath = FileSkin_v210.m_Skin.m_BtnPause[2].m_szPath; m_Body.m_ImgBtnPause[2].m_bTransparent = FileSkin_v210.m_Skin.m_BtnPause[2].m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBtnPause[2].m_Place, FileSkin_v210.m_Skin.m_BtnPause[2].m_Place);
      m_Body.m_ImgBtnPause[3].m_strPath = FileSkin_v210.m_Skin.m_BtnPause[3].m_szPath; m_Body.m_ImgBtnPause[3].m_bTransparent = FileSkin_v210.m_Skin.m_BtnPause[3].m_bTransparent; CONVERT_PLACE(m_Body.m_ImgBtnPause[3].m_Place, FileSkin_v210.m_Skin.m_BtnPause[3].m_Place);
   #undef CONVERT_PLACE
      m_Body.m_Font.lfHeight         = FileSkin_v210.m_Skin.m_Font.lfHeight;
      m_Body.m_Font.lfWidth          = FileSkin_v210.m_Skin.m_Font.lfWidth;
      m_Body.m_Font.lfEscapement     = FileSkin_v210.m_Skin.m_Font.lfEscapement;
      m_Body.m_Font.lfOrientation    = FileSkin_v210.m_Skin.m_Font.lfOrientation;
      m_Body.m_Font.lfWeight         = FileSkin_v210.m_Skin.m_Font.lfWeight; 
      m_Body.m_Font.lfItalic         = FileSkin_v210.m_Skin.m_Font.lfItalic;
      m_Body.m_Font.lfUnderline      = FileSkin_v210.m_Skin.m_Font.lfUnderline;
      m_Body.m_Font.lfStrikeOut      = FileSkin_v210.m_Skin.m_Font.lfStrikeOut;
      m_Body.m_Font.lfCharSet        = FileSkin_v210.m_Skin.m_Font.lfCharSet;
      m_Body.m_Font.lfOutPrecision   = FileSkin_v210.m_Skin.m_Font.lfOutPrecision;
      m_Body.m_Font.lfClipPrecision  = FileSkin_v210.m_Skin.m_Font.lfClipPrecision;
      m_Body.m_Font.lfQuality        = FileSkin_v210.m_Skin.m_Font.lfQuality;
      m_Body.m_Font.lfPitchAndFamily = FileSkin_v210.m_Skin.m_Font.lfPitchAndFamily;
      USES_CONVERSION;
      lstrcpyn((LPTSTR)m_Body.m_Font.lfFaceName, A2CT(FileSkin_v210.m_Skin.m_Font.lfFaceName), LF_FACESIZE);

      m_Body.m_ColorText.m_colorOpen[CCell::_Nil ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_Nil ];
      m_Body.m_ColorText.m_colorOpen[CCell::_1   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_1   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_2   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_2   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_3   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_3   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_4   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_4   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_5   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_5   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_6   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_6   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_7   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_7   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_8   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_8   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_9   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_9   ];
      m_Body.m_ColorText.m_colorOpen[CCell::_10  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_10  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_11  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_11  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_12  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_12  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_13  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_13  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_14  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_14  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_15  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_15  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_16  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_16  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_17  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_17  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_18  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_18  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_19  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_19  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_20  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_20  ];
      m_Body.m_ColorText.m_colorOpen[CCell::_21  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_21  ];
    //m_Body.m_ColorText.m_colorOpen[CCell::_Mine] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionOpen[nsVer210::_Mine]; //   2.10  

      m_Body.m_ColorText.m_colorClose[CCell::_Unknown] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionClose[nsVer210::_Unknown];
      m_Body.m_ColorText.m_colorClose[CCell::_Clear  ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionClose[nsVer210::_Clear  ];
    //m_Body.m_ColorText.m_colorClose[CCell::_Flag   ] = FileSkin_v210.m_Skin.m_ColorText.m_colorCaptionClose[nsVer210::_Flag   ]; //   2.10  

      m_Body.m_Border.m_colorShadow = FileSkin_v210.m_Skin.m_Border.m_colorShadow;
      m_Body.m_Border.m_colorLight  = FileSkin_v210.m_Skin.m_Border.m_colorLight;
      m_Body.m_Border.m_iWidth      = FileSkin_v210.m_Skin.m_Border.m_iWidth;
      m_Body.SetBkColor(              FileSkin_v210.m_Skin.m_colorBk);
      m_Body.m_bToAll               = FileSkin_v210.m_Skin.m_bToAll;

      m_Body.m_iTimerPause = CSkin().m_iTimerPause;

   }
   return bRes;
}

////////////////////////////////////////////////////////////////////////////////
//                           implementation CSkinMenu
////////////////////////////////////////////////////////////////////////////////

/* static */ CSkin CSkinMenu::LoadSkin(HMENU hMenu, UINT id) {
   CFileSkin FileSkin;
   FileSkin.SetSkinName(::GetMenuString(hMenu, id, MF_BYCOMMAND));
   BOOL bRes = FileSkin.LoadFile();
   if (bRes) {
      return FileSkin.GetSkin();
   }
   ::MessageBox(::GetActiveWindow(), CLang::GetString(IDS__FILESKIN__RESTORED_DEFAULT_SKIN), CLang::GetString(IDS__INFORMATION), MB_ICONSTOP | MB_OK);
   return CSkin();
}

/* static */ BOOL CALLBACK CSkinMenu::FileEnumProc(IN LPCTSTR szDirName, IN LPCTSTR szFileName, IN UINT iPos, IN LPVOID lpUserData) {
   HMENU hMenu = (HMENU)lpUserData;
   CString strFileName(szFileName, lstrlen(szFileName)-4);
   MENUITEMINFO mii = { sizeof(MENUITEMINFO),              // cbSize
                        MIIM_TYPE | MIIM_STATE | MIIM_ID,  // fMask
                        MFT_STRING,                        // fType
                        MFS_ENABLED,                       // fState
                        IDM_OPTIONS_SKIN_LOAD0+iPos+1,     // wID
                        NULL,                              // hSubMenu
                        NULL,                              // hbmpChecked
                        NULL,                              // hbmpUnchecked
                        0,                                 // dwItemData
                        (LPTSTR)(LPCTSTR)strFileName,      // dwTypeData
                        MAX_PATH };                        // cch
   ::InsertMenuItem(hMenu, iPos+1, TRUE, &mii);
   return TRUE;
}

/* static */ void CSkinMenu::LoadMenuList(HMENU hMenu) {
   ::EnumFiles(CFileSkin::GetAllSkinDir(), _T("*.")+CFileSkin::GetSkinFileExtension(), CSkinMenu::FileEnumProc, hMenu);
   GetFM2WinMain().SetOwnerDrawMenu(hMenu);
}

/* static */ void CSkinMenu::ReloadMenuList(HMENU hMenu){
   int count = ::GetMenuItemCount(hMenu);
   if (count == -1) return;
   if (count>1)
      for (int i=1; i<=count; i++)
         ::RemoveMenu(hMenu, 1, MF_BYPOSITION);
   CSkinMenu::LoadMenuList(hMenu);
}

void CFileSkin::ChangePathAndCopy(CString &strImgPath) {
   CString strFileName = strImgPath;
   if (!strFileName.IsEmpty()) {
      if (::FileExist(strFileName)) {
         //  -  
         CString strNewFile = GetThisSkinSubDir()+_T('\\')+::GetFileName(strFileName);
         BOOL bRes = FALSE;
         if (CKernel32Lib::CreateHardLink())
            bRes = CKernel32Lib::CreateHardLink()(strNewFile, strFileName, NULL);
         if (!bRes)
            bRes = ::CopyFile(strFileName, strNewFile, TRUE);
         //if (bRes || (::GetLastError()==ERROR_FILE_EXISTS))
         strImgPath = ::GetFileName(strNewFile);
      } else {
         //  -   
         CImage::CResourceHelper Help(strFileName);
         if (Help.GetModuleName().IsEmpty()) {
            //   
            strImgPath = strFileName;
         } else {
            if (Help.GetModuleName().CompareNoCase(::GetModuleFileName())==0) {
               //   
               strImgPath = strFileName.Mid(Help.GetModuleName().GetLength()); // 
            } else {
               //    -   
               CString strTemp = Help.SaveToTempRandomFile(m_strSkinName);
               if (strTemp.IsEmpty() || !CImage(strTemp).Valid()) {
                  //      
                  //  .  -     

                  //     __    
                  CString strNewFile = GetThisSkinSubDir()+_T('\\')+::GetFileName(Help.GetModuleName());
                  BOOL bRes = FALSE;
                  if (CKernel32Lib::CreateHardLink())
                     bRes = CKernel32Lib::CreateHardLink()(strNewFile, Help.GetModuleName(), NULL);
                  if (!bRes)
                     bRes = ::CopyFile(Help.GetModuleName(), strNewFile, TRUE);
                  //if (bRes || (::GetLastError()==ERROR_FILE_EXISTS))
                  strImgPath = CImage::CResourceHelper(::GetFileName(Help.GetModuleName()), Help.GetResourceName(), Help.GetResourceType()).MakePath();
                  if (!strTemp.IsEmpty())
                     ::DeleteFile(strTemp);
               } else {
                  //      
                  CString strNewFile = GetThisSkinSubDir()+_T('\\')+::GetFileName(strTemp);
                  BOOL bRes = ::MoveFile(strTemp, strNewFile);
                  if (bRes)
                     strImgPath = ::GetFileName(strNewFile);
               }
            }
         }
      }
   }
}

void CFileSkin::SetSkin(const CSkin skin) {
   m_Body = skin;

#ifdef _DEBUG
   //_ASSERT_EXPR(!m_strSkinName.IsEmpty(), L" CFileSkin::SetSkin       -  CFileSkin::SetSkinName!");
   _ASSERTE(!m_strSkinName.IsEmpty());
#endif

   //        
   ChangePathAndCopy(m_Body.m_ImgMine       .m_strPath);
   ChangePathAndCopy(m_Body.m_ImgFlag       .m_strPath);
   for (int i=0; i<m_Body.m_ImgsPause.GetSize(); i++) {
      ChangePathAndCopy(m_Body.m_ImgsPause.GetImgRef(i).m_strPath);
   }
   ChangePathAndCopy(m_Body.m_ImgBckgrnd    .m_strPath);
   ChangePathAndCopy(m_Body.m_ImgBtnNew  [0].m_strPath);
   ChangePathAndCopy(m_Body.m_ImgBtnNew  [1].m_strPath);
   ChangePathAndCopy(m_Body.m_ImgBtnNew  [2].m_strPath);
   ChangePathAndCopy(m_Body.m_ImgBtnNew  [3].m_strPath);
   ChangePathAndCopy(m_Body.m_ImgBtnPause[0].m_strPath);
   ChangePathAndCopy(m_Body.m_ImgBtnPause[1].m_strPath);
   ChangePathAndCopy(m_Body.m_ImgBtnPause[2].m_strPath);
   ChangePathAndCopy(m_Body.m_ImgBtnPause[3].m_strPath);
}

CSkin CFileSkin::GetSkin() const {
   CSkin &Skin = *const_cast<CSkin*>(&m_Body);

   //     
   CString strPath = GetThisSkinSubDir()+_T('\\');
#define CHANGE_PATH(strImgPath)  \
   if (!(strImgPath).IsEmpty()) { \
      if ((strImgPath).GetAt(0) != _T('?')) \
      strImgPath = strPath + strImgPath; \
   }
   CHANGE_PATH(Skin.m_ImgMine       .m_strPath)
   CHANGE_PATH(Skin.m_ImgFlag       .m_strPath)
   for (int i=0; i<Skin.m_ImgsPause.GetSize(); i++) {
      CHANGE_PATH(Skin.m_ImgsPause.GetImgRef(i).m_strPath);
      //CImageSerialize img = Skin.m_ImgsPause.GetImg(i);
      //CHANGE_PATH(img.m_strPath);
      //Skin.m_ImgsPause.SetImg(i, img);
   }
   CHANGE_PATH(Skin.m_ImgBckgrnd    .m_strPath)
   CHANGE_PATH(Skin.m_ImgBtnNew  [0].m_strPath)
   CHANGE_PATH(Skin.m_ImgBtnNew  [1].m_strPath)
   CHANGE_PATH(Skin.m_ImgBtnNew  [2].m_strPath)
   CHANGE_PATH(Skin.m_ImgBtnNew  [3].m_strPath)
   CHANGE_PATH(Skin.m_ImgBtnPause[0].m_strPath)
   CHANGE_PATH(Skin.m_ImgBtnPause[1].m_strPath)
   CHANGE_PATH(Skin.m_ImgBtnPause[2].m_strPath)
   CHANGE_PATH(Skin.m_ImgBtnPause[3].m_strPath)
#undef CHANGE_PATH

   return Skin;
}
