////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "TemplateSelectImage.h" -     
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__DAILOGTEMPLATESELECTIMAGE__
#define __FILE__DAILOGTEMPLATESELECTIMAGE__

#include <vector>
#include "../Control/ButtonFM.h"
#include "../Control/EditFM.h"
#include "../Resource.h"

#ifndef _WTL_VER

class CDialogTemplateSelectImage {
private:
   typedef std::vector<CImage*> VEC_pImg;
public:
   HWND m_hWnd;
   CString m_strFile;
   CString m_strResTypeAndName;
private:
   CString const m_strInitialDir;
   CString const m_strTitle;
   CString const m_strDefExt;

   CEditFM      m_InfoText;
   CButtonExFM  m_BtnOk, m_BtnCancel;
   OPENFILENAME m_ofn;
   CImage m_Img;
   VEC_pImg m_ImgRes;
   int m_iClickSubItem;
private:
   static LPCTSTR IDD() { static TCHAR szResourceName[] = _T("TemplateSelectImage"); return szResourceName; }
   static UINT_PTR CALLBACK DialogProcThis(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
      //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogTemplateSelectImage::DialogProcThis: %s "), (LPCTSTR)CLogger::WindowMessage(uMsg));
      CDialogTemplateSelectImage *This = NULL;
      if (uMsg == WM_INITDIALOG) {
         if (lParam) {
            OPENFILENAME &ofn = *(LPOPENFILENAME)lParam;
            This = (CDialogTemplateSelectImage*)ofn.lCustData;
            if (This) {
               This->m_hWnd = hWnd;
               ::SetWindowUserData(hWnd, (LONG_PTR)This);
            }
         }
      } else {
         This = (CDialogTemplateSelectImage*)::GetWindowUserData(hWnd);
      }
      if (This) {
         return This->DialogProc(hWnd, uMsg, wParam, lParam);
      }
      switch (uMsg) {
      HANDLE_MSG(hWnd, WM_MEASUREITEM, OnMeasureItemThis); //   WM_MEASUREITEM   WM_INITDIALOG
      }
      return 0;
   }
   UINT_PTR DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
      //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogTemplateSelectImage:DialogProc: uMsg: %s "), (LPCTSTR)CLogger::WindowMessage(uMsg));
      switch (uMsg){
      HANDLE_MSG(m_hWnd, WM_INITDIALOG , OnInitDialog);
      HANDLE_MSG(m_hWnd, WM_MEASUREITEM, OnMeasureItem);
      HANDLE_MSG(m_hWnd, WM_DRAWITEM   , OnDrawItem);
      HANDLE_MSG(m_hWnd, WM_SIZE       , OnSize);
      HANDLE_MSG(m_hWnd, WM_PAINT      , OnPaint);
      HANDLE_MSG(m_hWnd, WM_ERASEBKGND , OnEraseBkgnd);
    //HANDLE_MSG(m_hWnd, WM_CLOSE      , OnClose);
      HANDLE_MSG(m_hWnd, WM_DESTROY    , OnDestroy);
      case WM_NOTIFY: return OnNotify(hWnd, (int)wParam, (LPNMHDR)lParam); break;
      }
      return FALSE;
   }
   LRESULT OnNotify(HWND, int idCtrl, LPNMHDR pnmh) {
      //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogTemplateSelectImage:OnNotify: notify %s"), (LPCTSTR)CDNotify(pnhm->code));
      if (pnmh) {
         switch (pnmh->code) {
       //case NM_CUSTOMDRAW: return OnNotifyCustomDraw  (*(LPNMLVCUSTOMDRAW)pnmh);
         case CDN_SELCHANGE: return OnNotifySelectChange(*(LPOFNOTIFY      )pnmh);
         case NM_CLICK     : return OnNotifyClickCell   (*(LPNMITEMACTIVATE)pnmh, false);
         case NM_DBLCLK    : return OnNotifyClickCell   (*(LPNMITEMACTIVATE)pnmh, true);
         }
      }
      return 0;
   }

public:
   CDialogTemplateSelectImage(HWND hWndParent=NULL, LPCTSTR szFile=NULL, LPCTSTR szInitialDir=NULL, LPCTSTR szTitle=NULL, LPCTSTR szDefExt=NULL);
   INT_PTR CDialogTemplateSelectImage::DoModal(HWND hWndParent = NULL);

private:
   static void OnMeasureItemThis(HWND, LPMEASUREITEMSTRUCT);

   BOOL OnInitDialog (HWND, HWND, LPARAM);
   void OnMeasureItem(HWND, LPMEASUREITEMSTRUCT lpMeasureItem) { CDialogTemplateSelectImage::OnMeasureItemThis(m_hWnd, lpMeasureItem); }
   void OnDrawItem   (HWND, const DRAWITEMSTRUCT*);
   void OnSize       (HWND, UINT state, int cx, int cy);
   void OnPaint      (HWND);
   void OnClose      (HWND);
   void OnDestroy    (HWND);
   BOOL OnEraseBkgnd (HWND, HDC);

   LRESULT OnNotifyCustomDraw  (NMLVCUSTOMDRAW &nmcd);
   LRESULT OnNotifySelectChange(OFNOTIFY       &ofn);
   LRESULT OnNotifyClickCell   (NMITEMACTIVATE &ia, bool);

   int  InsertColumn(int nCol, LPCTSTR lpszColumnHeading, int nFormat, int nWidth, int nSubItem);
 //int  AddColumn(LPCTSTR strItem, int nItem, int nSubItem = -1, int nMask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM, int nFmt = LVCFMT_LEFT);
   int  AddItem(int nItem, int nSubItem, LPCTSTR strItem, int nImageIndex = -1);
 //int  GetItemText(int nItem, int nSubItem, CString& strText) const;
	void GetCellRect(int iCol, const RECTEX& rcItem, RECTEX& rcCell) const;

   void ClearTable();
   void FillTable();
   void SetErrorText(DWORD dwErrCode = ::GetLastError()) { ::SetWindowText(m_InfoText.m_hWnd, (dwErrCode == NO_ERROR) ? _T("") : ::ErrorCode2Str(dwErrCode)); }

   //  
   static BOOL CALLBACK EnumResLangFunc(HMODULE hModule, LPCTSTR lpszType, LPCTSTR lpszName, WORD wIDLanguage, LONG lParam);
   static BOOL CALLBACK EnumResNameFunc(HMODULE hModule, LPCTSTR lpszType, LPTSTR lpszName, LONG lParam);
   static BOOL CALLBACK EnumResourceFunc(HMODULE hModule, LPTSTR lpszType, LONG_PTR lParam);

   void AddToImgList(LPCTSTR);
};

////////////////////////////////////////////////////////////////////////////////////////////////////////
#else // _WTL_VER
////////////////////////////////////////////////////////////////////////////////////////////////////////

class CDialogTemplateSelectImage: public CFileDialogImpl<CDialogTemplateSelectImage>,
                                  public CWinDataExchange<CDialogTemplateSelectImage>,
                                  public COwnerDraw<CDialogTemplateSelectImage>
{
private:
   typedef std::vector<CImage*> VEC_pImg;
   class CButtonImpl  : public CWindowImpl<CButtonImpl  , CButton      > { DECLARE_EMPTY_MSG_MAP() };
   class CListViewImpl: public CWindowImpl<CListViewImpl, CListViewCtrl> { DECLARE_EMPTY_MSG_MAP() };
public:
   CString m_strFile;
   CString m_strResTypeAndName;
private:
   CString const m_strInitialDir;
   CString const m_strTitle;
   CString const m_strDefExt;

   CButtonImpl   m_BorderRes;
   CButtonImpl   m_BorderImg;
   CEditFM       m_InfoText;
   CListViewImpl m_ListRes;
   CButtonExFM   m_BtnOk, m_BtnCancel;
   CImage m_Img;
   VEC_pImg m_ImgRes;
   int m_iClickSubItem;
private:
   static LPCTSTR IDD() { static TCHAR szResourceName[] = _T("TemplateSelectImage"); return szResourceName; }
   BEGIN_MSG_MAP_EX(CDialogTemplateSelectImage)
      MSG_WM_INITDIALOG (OnInitDialog)
      CHAIN_MSG_MAP(COwnerDraw<CDialogTemplateSelectImage>)
      MSG_WM_SIZE       (OnSize)
      MSG_WM_PAINT      (OnPaint)
      MSG_WM_ERASEBKGND (OnEraseBkgnd)
    //MSG_WM_CLOSE      (OnClose)
      MSG_WM_DESTROY    (OnDestroy)

    //NOTIFY_HANDLER_EX(IDC_TEMPLATESELECTIMAGE_LIST_RESOURCE, NM_CUSTOMDRAW, OnNotifyCustomDraw  )
      NOTIFY_CODE_HANDLER_EX(                                  CDN_SELCHANGE, OnNotifySelectChange)
      NOTIFY_HANDLER_EX(IDC_TEMPLATESELECTIMAGE_LIST_RESOURCE, NM_CLICK     , OnNotifyClickCell   )
      NOTIFY_HANDLER_EX(IDC_TEMPLATESELECTIMAGE_LIST_RESOURCE, NM_DBLCLK    , OnNotifyClickCell   )
   END_MSG_MAP()
	BEGIN_DDX_MAP(CDialogAbout)
    //DDX_CONTROL(IDOK                                   , m_BtnOk)
    //DDX_CONTROL(IDCANCEL                               , m_BtnCancel)
      DDX_CONTROL(IDC_TEMPLATESELECTIMAGE_BORDER_RESOURCE, m_BorderRes)
      DDX_CONTROL(IDC_TEMPLATESELECTIMAGE_BORDER_IMAGE   , m_BorderImg)
      DDX_CONTROL(IDC_TEMPLATESELECTIMAGE_INFO_TEXT      , m_InfoText)
      DDX_CONTROL(IDC_TEMPLATESELECTIMAGE_LIST_RESOURCE  , m_ListRes)
	END_DDX_MAP()

public:
   CDialogTemplateSelectImage(HWND hWndParent=NULL, LPCTSTR szFile=NULL, LPCTSTR szInitialDir=NULL, LPCTSTR szTitle=NULL, LPCTSTR szDefExt=NULL);
   INT_PTR CDialogTemplateSelectImage::DoModal(HWND hWndParent = NULL);

   void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItem) { OnMeasureItem(0, lpMeasureItem); }
   void DrawItem   (LPDRAWITEMSTRUCT    lpDrawItem   ) { OnDrawItem   (0, lpDrawItem   ); }
private:
   BOOL OnInitDialog (HWND, LPARAM);
   void OnMeasureItem(UINT, LPMEASUREITEMSTRUCT);
   void OnDrawItem   (UINT, LPDRAWITEMSTRUCT);
   void OnSize       (UINT, CSize&);
   void OnPaint      (HDC);
   void OnClose      ();
   void OnDestroy    ();
   BOOL OnEraseBkgnd (HDC);

   LRESULT OnNotifyCustomDraw  (LPNMHDR);
   LRESULT OnNotifySelectChange(LPNMHDR);
   LRESULT OnNotifyClickCell   (LPNMHDR);

   int  InsertColumn(int nCol, LPCTSTR lpszColumnHeading, int nFormat, int nWidth, int nSubItem);
 //int  AddColumn(LPCTSTR strItem, int nItem, int nSubItem = -1, int nMask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM, int nFmt = LVCFMT_LEFT);
   int  AddItem(int nItem, int nSubItem, LPCTSTR strItem, int nImageIndex = -1);
 //int  GetItemText(int nItem, int nSubItem, CString& strText) const;
	void GetCellRect(int iCol, const RECTEX& rcItem, RECTEX& rcCell) const;

   void ClearTable();
   void FillTable();
   void SetErrorText(DWORD dwErrCode = ::GetLastError()) { m_InfoText.SetWindowText((dwErrCode == NO_ERROR) ? _T("") : ::ErrorCode2Str(dwErrCode)); }

   //  
   static BOOL CALLBACK EnumResLangFunc(HMODULE hModule, LPCTSTR lpszType, LPCTSTR lpszName, WORD wIDLanguage, LONG lParam);
   static BOOL CALLBACK EnumResNameFunc(HMODULE hModule, LPCTSTR lpszType, LPTSTR lpszName, LONG lParam);
   static BOOL CALLBACK EnumResourceFunc(HMODULE hModule, LPTSTR lpszType, LONG_PTR lParam);

   void AddToImgList(LPCTSTR);
};

#endif // _WTL_VER

#endif // __FILE__DAILOGTEMPLATESELECTIMAGE__
