////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "Quadrangle1.h"
//
//   CQuadrangle1 -  120-90-60-90
// Copyright (C) 2002-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__QUADRANGLE1__
#define __FILE__QUADRANGLE1__

#include "./Base.h"

class CQuadrangle1: public CCell {
private:
   static float& m_b () { static float  b; return  b; }
   static float& m_h () { static float  h; return  h; }
   static float& m_n () { static float  n; return  n; }
   static float& m_m () { static float  m; return  m; }
   static float& m_Z () { static float  Z; return  Z; }
   static float& m_Zx() { static float Zx; return Zx; }
   static float& m_Zy() { static float Zy; return Zy; }
public:
   static SIZE GetSizeInPixel(const SIZE &sizeField, int iArea);
   static int SizeInscribedSquare(int iArea, int iBorderWidth);
public:
   CQuadrangle1(const COORD &Coord, const SIZE &sizeField, int iArea, const CGraphicContext &gContext);
   void SetPoint(int iArea); //       
   void Paint() const;
};

#endif // __FILE__QUADRANGLE1__
