////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "MenuItemEx.h"
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__CMENUITEM_EXTENDET__
#define __FILE__CMENUITEM_EXTENDET__

#include "./MenuItem.h"

//       
class CMenuItemEx: public CMenuItem {
public:
   CMenuItemEx(BOOL bPopup, HMENU hMenu, UINT uItem, BOOL fByPosition, const CImage *pImg = NULL) : CMenuItem(bPopup, hMenu, uItem, fByPosition, pImg) {}
protected:
   virtual BOOL DrawBkgrnd(const DRAWITEMSTRUCT&, HDC, const RECTEX&, bool isSelect, bool isGrayed, bool isSeparator) const;
   virtual COLORREF GetMenuColor() const { return ::GetSysColor(COLOR_MENU); };
};

//        
class CMenuItemIridescence: public CMenuItemEx {
protected:
   BYTE m_Color[4][3];
   mutable RECTEX m_rcItemGradient;

public:
   CMenuItemIridescence(BOOL bPopup, HMENU hMenu, UINT uItem, BOOL fByPosition, const CImage *pImg = NULL) : CMenuItemEx(bPopup, hMenu, uItem, fByPosition, pImg) {
      for (int i=0; i<4; i++)
         for (int j=0; j<3; j++)
            m_Color[i][j] = 0xFF>>rand(8);
   }
protected:
   virtual BOOL DrawBkgrnd(const DRAWITEMSTRUCT&, HDC, const RECTEX&, bool isSelect, bool isGrayed, bool isSeparator) const;
   virtual void PostDraw  (const DRAWITEMSTRUCT&, HDC, const RECTEX&, bool isSelect, bool isGrayed, bool isSeparator) const;

private:
   static VOID CALLBACK TimerProc(HWND, UINT, UINT_PTR, DWORD);
   void OnTimer(HWND, UINT, DWORD);
};

#endif // __FILE__CMENUITEM_EXTENDET__
