////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "MenuItemFM.h"
// ,      
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__CMENUITEM_FASTMINES__
#define __FILE__CMENUITEM_FASTMINES__

#include "./MenuItemEx.h"

class CMenuItemFM: public CMenuItemEx {
public:
   CMenuItemFM(BOOL bPopup, HMENU hMenu, UINT uItem, BOOL fByPosition, const CImage *pImg = NULL);
protected:
   virtual BOOL GetLogFont(OUT LOGFONT&) const;
   virtual COLORREF GetMenuColor() const;
};

class CMenuItemIridescenceFM: public CMenuItemIridescence {
public:
   CMenuItemIridescenceFM(BOOL bPopup, HMENU hMenu, UINT uItem, BOOL fByPosition, const CImage *pImg = NULL) : CMenuItemIridescence(bPopup, hMenu, uItem, fByPosition, pImg) {}
protected:
   virtual BOOL GetLogFont(OUT LOGFONT&) const;
   virtual COLORREF GetMenuColor() const;
};


class CMenuNCDrawFM {
private:
   static BOOL OnNCPaint(HWND, HRGN, bool);
   static HRGN CreateRegionMenuUpdate(HWND);
public:
   static BOOL OnNCPaint(HWND hWnd, HRGN hRgn) { return OnNCPaint(hWnd, hRgn, true); } // WM_NCPAINT
   static BOOL OnNCActivate(HWND, WPARAM);                                             // WM_NCACTIVATE
};

#endif // __FILE__CMENUITEM_FASTMINES__
