////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "TabItemRot.cpp"
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "TabItemRot.h"

#define CTAB_ITEM__PROP_NAME _T("Tab")
#define DEFAULT_ELLAPSE 50
#define DEFAULT_ROTATION 0.3f

CTabItemRot::CTabItemRot() :
   m_fCurrAngle(0.f),
   m_dwEllapse(DEFAULT_ELLAPSE),
   m_fRoation(DEFAULT_ROTATION)
{}

CTabItemRot::CTabItemRot(HWND hWndTab, int iItem, const CImage *pImg) :
   CTabItem(hWndTab, iItem, pImg),
   m_fCurrAngle(0.f),
   m_dwEllapse(DEFAULT_ELLAPSE),
   m_fRoation(DEFAULT_ROTATION)
{}

/* static */ VOID CTabItemRot::TimerProc(HWND hWnd, UINT uMsg, UINT idEvent, DWORD dwTime) {
   BOOL bRes = ::KillTimer(hWnd, idEvent);

   UINT itemID = (UINT)(ULONG_PTR)::GetProp(hWnd, CTAB_ITEM__PROP_NAME);
   RECTEX rcItem;
   bRes = TabCtrl_GetItemRect(hWnd, itemID, &rcItem);
   bRes = ::InvalidateRect(hWnd, &rcItem, FALSE);
   CTabItemRot *This = (CTabItemRot*)GetInstance(hWnd, itemID);
   if (This) {
      This->m_fCurrAngle += This->m_fRoation;
   }
}

BOOL CTabItemRot::Draw(const DRAWITEMSTRUCT &di, HDC hDC, const RECTEX &rc) const {
   bool bSelected = !!(di.itemState & ODS_SELECTED);// (di.itemID == TabCtrl_GetCurSel(m_hWndTab)); //
   if (!bSelected) return FALSE;
   BOOL bRes = m_Img.DrawRotatedTransparent(hDC, rc, m_fCurrAngle, 0x123456);
   if (bRes) {
      /**/
      //HANDLE hResOld = ::RemoveProp(m_hWndTab, CTAB_ITEM__PROP_NAME);
      bRes = ::SetProp(m_hWndTab, CTAB_ITEM__PROP_NAME, (HANDLE)(ULONG_PTR)m_iItem);
      bRes = bRes && ::SetTimer(m_hWndTab, 0, m_dwEllapse, CTabItemRot::TimerProc);
      /** /
      RECTEX rcItem(di.rcItem);
      bRes = TabCtrl_GetItemRect(m_hWndTab, di.itemID, &rcItem);
      bRes = bRes && ::InvalidateRect(m_hWndTab, &rcItem, FALSE);
      m_fCurrAngle += m_fRoation;
      /**/
   }
   return bRes;
}
