////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "TabItemRot.h"
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__CTABITEM_ROTATED__
#define __FILE__CTABITEM_ROTATED__

#include "./TabItem.h"

class CTabItemRot: public CTabItem {
protected:
   mutable float m_fCurrAngle;
   float m_fRoation; // angle of rotation (degree of rotation)
   DWORD m_dwEllapse;

public:
   CTabItemRot();
   CTabItemRot(HWND hWndTab, int iItem, const CImage *pImg = NULL);

   void SetElapse(DWORD dwMilliSec) { m_dwEllapse = dwMilliSec; }
   void SetAngleRot(float fAngle) { m_fRoation = fAngle; }

private:
   static VOID CALLBACK TimerProc(HWND, UINT, UINT_PTR, DWORD);

protected:
   virtual BOOL Draw(const DRAWITEMSTRUCT&, HDC, const RECTEX&) const;
};

#endif // __FILE__CTABITEM_ROTATED__
