////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "OldVersion.h"
//     +        .         !
//
// Copyright (C) 2004-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////
//
// 2007.02.27
//    Add namespace nsVer20070212 for support version 2.2007.02.12
//
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__OLDVERSION__
#define __FILE__OLDVERSION__

#include "./Lib/CommonLib.h"
#include "./Lang.h"

#define MAX_INTEGER 0x7FFFFFFF

namespace nsVer200 {
   struct CChmpnRecord {
      char m_szPlayerName[20];
      int  m_iTime;
   };

   enum EMosaic {
      eMosaicSquare1,
      eMosaicSquare2,
      eMosaicTriangle1,
      eMosaicTriangle2,
      eMosaicHexagon1,
      eMosaicPentagonT24,
      eMosaicPentagonT10,
      eMosaicParquet1,
      eMosaicParquet2,
      eMosaicTrSq1,
      eMosaicSqTrHex,
      eMosaicTrapezoid1,
      eMosaicRhombus1,
      eMosaicNil
   };

   enum ESkillLevel {
      eSkillLevelBeginner,
      eSkillLevelAmateur,
      eSkillLevelProfessional,
      eSkillLevelCrazy,
      eSkillLevelCustom  //      !!!
   };

   struct CFileChmpn {
      CChmpnRecord m_Data[eMosaicNil][eSkillLevelCustom][10];
   };
} // namespace ver200

namespace nsVer210 {
   #define ID_VERSIONINFO_VERSION3_v210 "FastMines Project - version 2.1.0."

   struct CChmpnRecord {
      char m_szPlayerName[20];
      int  m_iTime;
      CChmpnRecord() {
         m_szPlayerName[0] = 0;
         m_iTime = MAX_INTEGER;
      };
   };

   enum EMosaic {
      // Triangle
      eMosaicTriangle1,
      eMosaicTriangle2,
      eMosaicTriangle3,
      eMosaicTriangle4,
      // Quadrangle
      eMosaicSquare1,
      eMosaicSquare2,
      eMosaicParquet1,
      eMosaicParquet2,
      eMosaicTrapezoid1,
      eMosaicTrapezoid2,
      eMosaicTrapezoid3,
      eMosaicRhombus1,
      eMosaicQuadrangle1,
      // Pentagon
      eMosaicPentagonT24,
      eMosaicPentagonT5,
      eMosaicPentagonT10,
      // Hexagon
      eMosaicHexagon1,
      // Other
      eMosaicTrSq1,
      eMosaicTrSq2,
      eMosaicSqTrHex,
      //
      eMosaicNil  //      !!!
   };

   enum ESkillLevel {
      eSkillLevelBeginner,
      eSkillLevelAmateur,
      eSkillLevelProfessional,
      eSkillLevelCrazy,
      eSkillLevelCustom  //      !!!
   };

   struct CFileChmpn {
      char m_szVersion[chDIMOF(_T(ID_VERSIONINFO_VERSION3_v210))];
      CChmpnRecord m_Data[eMosaicNil][eSkillLevelCustom][10];
      CFileChmpn() {
   #if (_MSC_VER >= 1400)
         strcpy_s(m_szVersion, chDIMOF(_T(ID_VERSIONINFO_VERSION3_v210)), ID_VERSIONINFO_VERSION3_v210);
   #else
         strcpy(m_szVersion, ID_VERSIONINFO_VERSION3_v210);
   #endif
      }
   };

   enum EPlace {
      ePlaceCenter,
      ePlaceStretch, // p
      ePlaceTile     // 
   };

   enum EOpen {_Nil, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _Mine};
   enum EClose{_Unknown, _Clear, _Flag};

   struct CFileSkin {
      char m_szVersion[chDIMOF(ID_VERSIONINFO_VERSION3_v210)];
      struct {
         struct {
            char m_szPath[MAX_PATH];
            bool m_bTransparent;
            EPlace m_Place;
         } m_Mine, m_Flag, m_Pause, m_Bckgrnd, m_BtnNew[4], m_BtnPause[4];
         COLORREF m_colorBk;
         bool m_bToAll;
         LOGFONTA m_Font;
         struct {
            COLORREF m_colorCaptionOpen [_Mine];
            COLORREF m_colorCaptionClose[_Flag];
         } m_ColorText;
         struct {
            COLORREF m_colorShadow,
                     m_colorLight;
            int m_iWidth;
         } m_Border;
      } m_Skin;
      CFileSkin () {
         memset(this, 0, sizeof(*this));
   #if (_MSC_VER >= 1400)
         strcpy_s(m_szVersion, chDIMOF(ID_VERSIONINFO_VERSION3_v210), ID_VERSIONINFO_VERSION3_v210);
   #else
         strcpy(m_szVersion, ID_VERSIONINFO_VERSION3_v210);
   #endif
      }
   };

   struct CSttstcSubRecord {
      DWORD
         m_dwGameNumber, //   
         m_dwGameWin,    //   
         m_dwOpenField,  //     -     
         m_dwPlayTime,   //    -         
         m_dwClickCount; //    -       
   };
   struct CSttstcRecord {
      CHAR             m_szPlayerName[20];
      CHAR             m_szPassword  [20];
      CSttstcSubRecord m_Record[eMosaicNil][eSkillLevelCustom];
   };
   struct CSttstcFile {
      CSttstcRecord m_DataStc; //    
      CSttstcRecord m_DataBad; // 
      DWORD m_dwCRC;
   };

} // namespace ver210

namespace nsVer20070212 {
   struct ISerialize {
      virtual BOOL SerializeRead (HANDLE hFile) = 0;
   };
   struct IFile {
      virtual HANDLE GetFileHandle() const = 0;
      virtual BOOL LoadFile() = 0;
      virtual BOOL IgnoreFileNotFound() const = 0; //   ERROR_FILE_NOT_FOUND   ?
   };

   struct IFileHeader: public ISerialize { // serialize header
   };

   struct IFileBody : public ISerialize { // serialize body
   };

   struct CImg {
      enum EPlace {
         // alignment
         ePlaceLeft      = 0x00,
         ePlaceCenter    = 0x01,
         ePlaceRight     = 0x02,

         ePlaceTop       = 0x00,
         ePlaceMiddle    = 0x04,
         ePlaceBottom    = 0x08,

         // placement
         ePlaceAsIs      = 0x00, //   
         ePlaceUniformly = 0x10, //  
         ePlaceStretch   = 0x20, //  
         ePlaceTile      = 0x30  // 
      };

      enum EImageType {
         eImageBMP,
         eImageICO,
         eImageWMF,
         eImageEMF,
         eImageOTH, // others image (instance of CImageEasy)
         eImageUnk
      };
   };

   struct CImageSerialize : public CImg {
      CString  m_strPath;
      BOOL     m_bTransparent; // image is transparent ? (only for .bmp image)
      COLORREF m_clrTransparent; // transparent color. If == CLR_INVALID then m_clrTransparent equals color of the pixel(0,0)
      BYTE     m_Place;
      CImageSerialize() :
         m_bTransparent  (TRUE),
         m_clrTransparent(CLR_INVALID),
         m_Place         (ePlaceStretch | ePlaceCenter | ePlaceMiddle) {}
      CImageSerialize(CString strPath, BOOL bTransparent = TRUE, COLORREF clrTransparent = CLR_INVALID, BOOL flagPlace = ePlaceStretch | ePlaceCenter | ePlaceMiddle) :
         m_strPath       (strPath),
         m_bTransparent  (bTransparent),
         m_clrTransparent(clrTransparent),
         m_Place         (flagPlace) {}
      const CImageSerialize& operator=(const CImageSerialize& image) {
         m_strPath        = image.m_strPath;
         m_bTransparent   = image.m_bTransparent;
         m_clrTransparent = image.m_clrTransparent;
         m_Place          = image.m_Place;
         return *this;
      }
      BOOL CImageSerialize::SerializeRead(HANDLE hFile) {
         DWORD dwNOBR = 0;
         return ::SerializeRead(hFile, m_strPath) &&
            (::ReadFile(hFile, &m_bTransparent  , sizeof(m_bTransparent  ), &dwNOBR, NULL) && (sizeof(m_bTransparent  ) == dwNOBR)) &&
            (::ReadFile(hFile, &m_clrTransparent, sizeof(m_clrTransparent), &dwNOBR, NULL) && (sizeof(m_clrTransparent) == dwNOBR)) &&
            (::ReadFile(hFile, &m_Place         , sizeof(m_Place         ), &dwNOBR, NULL) && (sizeof(m_Place         ) == dwNOBR)) &&
            ((m_Place>=ePlaceLeft) && (m_Place<=(ePlaceTile | ePlaceBottom | ePlaceRight)));
      }
   };

   enum EStatus{_Open, _Close};
   enum EOpen  {_Nil, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _Mine};
   enum EClose {_Unknown, _Clear, _Flag};

   struct CColorText {
      COLORREF m_colorOpen [_Mine+1];
      COLORREF m_colorClose[_Flag+1];
   };

   struct CBorder{
      COLORREF m_colorShadow,
               m_colorLight;
      int m_iWidth;                    //BBGGRR
   };

   struct CSkinMosaic : public ISerialize {
   public:
      CImageSerialize m_ImgMine, m_ImgFlag, m_ImgPause, m_ImgBckgrnd;
      LOGFONT         m_Font;
      CCell::CColorText m_ColorText;
      CCell::CBorder    m_Border;
   private:
      COLORREF m_colorBk;
   public:
      COLORREF GetBkColor() const { return (m_colorBk==CLR_INVALID) ? ::GetSysColor(COLOR_BTNFACE) : m_colorBk; }
      BOOL SerializeRead(HANDLE hFile) {
         DWORD dwNOBR = 0;
         BOOL bUnicode;
         LOGFONTA lfA;
         LOGFONTW lfW;
         BOOL bRes = m_ImgMine   .SerializeRead(hFile) &&
                     m_ImgFlag   .SerializeRead(hFile) &&
                     m_ImgPause  .SerializeRead(hFile) &&
                     m_ImgBckgrnd.SerializeRead(hFile) &&
                     (::ReadFile(hFile, &bUnicode   , sizeof(bUnicode   ), &dwNOBR, NULL) && (sizeof(bUnicode   ) == dwNOBR)) &&
                    ( bUnicode ?
                     (::ReadFile(hFile, &lfW        , sizeof(lfW        ), &dwNOBR, NULL) && (sizeof(lfW        ) == dwNOBR)) :
                     (::ReadFile(hFile, &lfA        , sizeof(lfA        ), &dwNOBR, NULL) && (sizeof(lfA        ) == dwNOBR))
                    ) &&
                     (::ReadFile(hFile, &m_ColorText, sizeof(m_ColorText), &dwNOBR, NULL) && (sizeof(m_ColorText) == dwNOBR)) &&
                     (::ReadFile(hFile, &m_Border   , sizeof(m_Border   ), &dwNOBR, NULL) && (sizeof(m_Border   ) == dwNOBR)) &&
                     (::ReadFile(hFile, &m_colorBk  , sizeof(m_colorBk  ), &dwNOBR, NULL) && (sizeof(m_colorBk  ) == dwNOBR));
         if (bRes) {
            if (bUnicode) {
   #ifdef _UNICODE
               m_Font = lfW;
   #else
               m_Font.lfHeight          = lfW.lfHeight;
               m_Font.lfWidth           = lfW.lfWidth;
               m_Font.lfEscapement      = lfW.lfEscapement;
               m_Font.lfOrientation     = lfW.lfOrientation;
               m_Font.lfWeight          = lfW.lfWeight; 
               m_Font.lfItalic          = lfW.lfItalic;
               m_Font.lfUnderline       = lfW.lfUnderline;
               m_Font.lfStrikeOut       = lfW.lfStrikeOut;
               m_Font.lfCharSet         = lfW.lfCharSet;
               m_Font.lfOutPrecision    = lfW.lfOutPrecision;
               m_Font.lfClipPrecision   = lfW.lfClipPrecision;
               m_Font.lfQuality         = lfW.lfQuality;
               m_Font.lfPitchAndFamily  = lfW.lfPitchAndFamily;
               USES_CONVERSION;
               lstrcpyn((LPTSTR)m_Font.lfFaceName, W2CT(lfW.lfFaceName), LF_FACESIZE);
   #endif
            } else {
   #ifdef _UNICODE
               m_Font.lfHeight          = lfA.lfHeight;
               m_Font.lfWidth           = lfA.lfWidth;
               m_Font.lfEscapement      = lfA.lfEscapement;
               m_Font.lfOrientation     = lfA.lfOrientation;
               m_Font.lfWeight          = lfA.lfWeight; 
               m_Font.lfItalic          = lfA.lfItalic;
               m_Font.lfUnderline       = lfA.lfUnderline;
               m_Font.lfStrikeOut       = lfA.lfStrikeOut;
               m_Font.lfCharSet         = lfA.lfCharSet;
               m_Font.lfOutPrecision    = lfA.lfOutPrecision;
               m_Font.lfClipPrecision   = lfA.lfClipPrecision;
               m_Font.lfQuality         = lfA.lfQuality;
               m_Font.lfPitchAndFamily  = lfA.lfPitchAndFamily;
               USES_CONVERSION;
               lstrcpyn((LPTSTR)m_Font.lfFaceName, A2CT(lfA.lfFaceName), LF_FACESIZE);
   #else
               m_Font = lfA;
   #endif
            }
         }
         return bRes;
      }
   };
   //////////////////////////////////////////////
   struct CSkin: public CSkinMosaic, public IFileBody {
      CImageSerialize m_ImgBtnNew  [4],
                      m_ImgBtnPause[4];
      BOOL            m_bToAll;
      BOOL SerializeRead(HANDLE hFile) {
         DWORD dwNOBR = 0;
         BOOL bRes = CSkinMosaic::SerializeRead(hFile) &&
                     m_ImgBtnNew  [0].SerializeRead(hFile) &&
                     m_ImgBtnNew  [1].SerializeRead(hFile) &&
                     m_ImgBtnNew  [2].SerializeRead(hFile) &&
                     m_ImgBtnNew  [3].SerializeRead(hFile) &&
                     m_ImgBtnPause[0].SerializeRead(hFile) &&
                     m_ImgBtnPause[1].SerializeRead(hFile) &&
                     m_ImgBtnPause[2].SerializeRead(hFile) &&
                     m_ImgBtnPause[3].SerializeRead(hFile) &&
                     (::ReadFile(hFile, &m_bToAll, sizeof(BOOL), &dwNOBR, NULL) && (sizeof(BOOL) == dwNOBR));
         if (!bRes) *this = CSkin();
         return bRes;
      }
   };

   template <DWORD TSignature>
   struct IFileHeaderImpl: public IFileHeader {
      DWORD   m_dwSignature;
      CString m_strVersion;
      static DWORD GetSignature() { return TSignature; }
      IFileHeaderImpl() :
         m_dwSignature(GetSignature()),
         m_strVersion(_T("FastMines Project - version ")+::GetFileVersion(::GetModuleFileName())) {}
      BOOL SerializeRead(HANDLE hFile) {
         DWORD dwNOBR = 0;
         BOOL bRes = (::ReadFile(hFile, &m_dwSignature, sizeof(m_dwSignature), &dwNOBR, NULL) && (sizeof(m_dwSignature) == dwNOBR) && (m_dwSignature == this->GetSignature())) &&
                      ::SerializeRead(hFile, m_strVersion);
         return bRes;
      }
   };

   template <class CFileHeader, class CFileBody, int TID_ERROR_READ,
                                                 int TID_ERROR_WRITE,
                                                 int TID_ERROR_VERSION>
   class CCommonSerialize : public ISerialize {
   protected:
      CFileBody m_Body;
   public:
      BOOL SerializeRead(HANDLE hFile) {
         int iIDString = 0;
         BOOL bRes = CFileHeader().SerializeRead(hFile);
         if (!bRes) {
            iIDString = TID_ERROR_VERSION;
         } else {
            bRes &= m_Body.SerializeRead(hFile);
            if (!bRes) {
               iIDString = TID_ERROR_READ;
            }
         }
         if (!bRes) {
            ::MessageBox(::GetActiveWindow(), CLang::GetString(iIDString), CLang::GetString(IDS__ERROR), MB_ICONERROR | MB_OK);
         }
         return bRes;
      }
   };

   template <class CFileHeader, class CFileBody, int TID_ERROR_CREATE,
                                                 int TID_ERROR_OPEN,
                                                 int TID_ERROR_READ,
                                                 int TID_ERROR_WRITE,
                                                 int TID_ERROR_VERSION>
   class CCommonSerializeEx : public CCommonSerialize<CFileHeader, CFileBody,
                                                      TID_ERROR_READ,
                                                      TID_ERROR_WRITE,
                                                      TID_ERROR_VERSION>, public IFile
   {
   public:
      BOOL LoadFile() {
         HANDLE hFile = this->GetFileHandle();
         BOOL bRes = (hFile != INVALID_HANDLE_VALUE);
         bRes = (::GetFileType(hFile) != FILE_TYPE_UNKNOWN); //     FILE_TYPE_UNKNOWN  GetLastError  INVALID_HANDLE      .
         if (!bRes) {
            DWORD dwErrCode = ::GetLastError();
            bRes = ((ERROR_FILE_NOT_FOUND == dwErrCode) && IgnoreFileNotFound());
            if (!bRes) {
               ::MessageBox(::GetActiveWindow(), CLang::GetString(TID_ERROR_OPEN)+_T("\r\n\r\n")+::ErrorCode2Str(dwErrCode), CLang::GetString(IDS__ERROR), MB_ICONSTOP | MB_OK);
            }
         } else {
            bRes = SerializeRead(hFile);
            //::CloseHandle(hFile); hFile = NULL; //    ,     ...
         }
         return bRes;
      }
   };
   struct CFileSkin : public CCommonSerializeEx<IFileHeaderImpl<0x84C0501B>, CSkin,
                                                IDS__FILESKIN__ERROR_CREATE,
                                                IDS__FILESKIN__ERROR_OPEN,
                                                IDS__FILESKIN__ERROR_READ,
                                                IDS__FILESKIN__ERROR_WRITE,
                                                IDS__FILESKIN__ERROR_VERSION>
   {
   private:
      HANDLE m_hFile;
   protected:
      BOOL IgnoreFileNotFound() const { return FALSE; }
   public:
      void   SetFileHandle(HANDLE hFile) { m_hFile = hFile; }
      HANDLE GetFileHandle() const { return m_hFile; }
      CSkin GetSkin() const { return m_Body; }
   };
} // namespace nsVer20070212

#endif // __FILE__OLDVERSION__
