////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "StorageMines.h"
//   ,     
// Copyright (C) 2005-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__STORAGEMINES__
#define __FILE__STORAGEMINES__

#include <Windows.h>
#include <vector>
#include "./Interface.h"

class CStorageMines : public ISerialize {
private:
   typedef std::vector<COORD> VECTOR_COORD;
   typedef VECTOR_COORD::iterator VECTOR_COORD_ITERATOR;
private:
   VECTOR_COORD m_CellMines;
private:
   VECTOR_COORD_ITERATOR Find(const COORD &Coord);
public:
  ~CStorageMines() { Reset(); }
   COORD operator[](size_t index) const { return m_CellMines[index]; }
   void  Reset() { m_CellMines.clear(); }
   BOOL Del(const COORD &Coord);
   BOOL Add(const COORD &Coord);
   size_t GetSize() const { return m_CellMines.size(); }

   BOOL SerializeRead (HANDLE hFile);
   BOOL SerializeWrite(HANDLE hFile) const;
};

#endif // __FILE__STORAGEMINES__
